// Copyright 2012-2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version.
//
// This Library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this Library.  If not, see <http://www.gnu.org/licenses/>.


#ifndef ESCWYP_CHAIN_EXTERN_H
#define ESCWYP_CHAIN_EXTERN_H
#include "escwyp_chain_params.h"


void chain_default_params(struct chain_params *the_params);
void print_params_chain(struct chain_params *the_params);
void chain_refresh_parameters();
void chain_set_params(struct chain_params *params);
void chain_set_freq(float freq);
void chain_set_freq_from_klavier(const float freq, const float low_freq, const float high_freq);
void chain_init_values();
void makeChains(const int chainLength, float *buff_L, const unsigned int srate);
void makeChain(const int chainLength, float *buff_L);
void makeChainSined(const int chainLength, float *buff_L, const unsigned int srate);

void chainConstructor();

float get_chain_delta();
float get_sined_chain_freq();
int get_chain_mode();

void set_chain_delta(const float delta);
void set_sined_chain_freq(const float freq);
void set_chain_mode(const int mode);
void chain_set_self_control(const int value);
int chain_get_self_control();

#endif
