// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#include "escwyp_chain_patch_eet.h"
#include "escwyp_chain_extern.h"
#include "escwyp_chain_gui_elm_extern.h"
#include "escwyp_patch_select_extern.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void chain_load_patch(const char *patch_name){

    fprintf(stdout, "III chain_load_patch\n");

    void *param_p;
    void *param_pp;
    char the_base_key[255];
    char the_key[255];
    the_base_key[0] = 47;
    the_base_key[1] = 0;
    strcat(the_base_key, "chain/"); 
    strcat(the_base_key, patch_name);

    // CHAIN DELTA----------------------
    strcpy(the_key, the_base_key);
    strcat(the_key, "/chain_delta");

    param_pp = escwyp_patch_load_param(param_p, the_key);
    if(param_pp){
       float *chain_delta = (float *) param_pp;
       set_chain_delta(*chain_delta);
       chain_delta_slider_set(*chain_delta);
       fprintf(stdout, "%s %f\n", the_key, *chain_delta);
       free(param_pp);
    }else{
       fprintf(stdout, "%s not there. Ohh.\n", the_key);
    }
    //--------------------------------

    // CHAIN FREQ----------------------
    strcpy(the_key, the_base_key);
    strcat(the_key, "/chain_freq");
    float *chain_freq;
    param_pp = escwyp_patch_load_param(param_p, the_key);
    if(param_pp){
       chain_freq = (float *) param_pp;
       
       set_sined_chain_freq(*chain_freq);
       chain_freq_slider_set(*chain_freq);
       fprintf(stdout, "%s %f\n", the_key, *chain_freq);
       free(chain_freq);
    }else{
       fprintf(stdout, "%s not there. Ohh.\n", the_key);
    }
    //--------------------------------

    // CHAIN MODE----------------------
    strcpy(the_key, the_base_key);
    strcat(the_key, "/chain_mode");
    int *chain_mode;
    param_pp = escwyp_patch_load_param(param_p, the_key);
    if(param_pp){
       chain_mode = (int *) param_pp;
       set_chain_mode(*chain_mode);
       chain_mode_check_set(*chain_mode);
       fprintf(stdout, "%s %i\n", the_key, *chain_mode);
       free(chain_mode );
    }else{
       fprintf(stdout, "%s not there. Ohh.\n", the_key);
    }
    //--------------------------------

}

void chain_save_patch(const char *patch_name){

    fprintf(stdout, "chain_save_patch\n");
    float chain_delta = 0.2;
    float chain_freq = 500.0;
    int chain_mode = 0; 

    char id_string[255];
    strcpy(id_string, "/PATCH_NAME/chain/");
    strcat(id_string, patch_name);
    escwyp_patch_save_param(patch_name, (1+strlen(patch_name))*sizeof(char), id_string);
    fprintf(stdout, "%s = %s\n", id_string, patch_name);

    char the_base_key[255];
    char the_key[255];
    the_base_key[0] = 47;
    the_base_key[1] = 0;
    strcat(the_base_key, "chain/"); 
    strcat(the_base_key, patch_name);

    chain_delta = get_chain_delta();
    strcpy(the_key, the_base_key);
    strcat(the_key, "/chain_delta");
    escwyp_patch_save_param(&chain_delta, sizeof(float), the_key);
    fprintf(stdout, "%s %f\n", the_key, chain_delta);

    chain_freq = get_sined_chain_freq();
    strcpy(the_key, the_base_key);
    strcat(the_key, "/chain_freq");
    escwyp_patch_save_param(&chain_freq, sizeof(float), the_key);
    fprintf(stdout, "%s %f\n", the_key, chain_freq);

    chain_mode = get_chain_mode();
    strcpy(the_key, the_base_key);
    strcat(the_key, "/chain_mode");
    escwyp_patch_save_param(&chain_mode, sizeof(int), the_key);
    fprintf(stdout, "%s %i\n", the_key, chain_mode);

}
