// Copyright 2015, Jean Rene Dawin
//
// This Program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.

#include "escwyp_klavier.h"
#include "escwyp_line_draw.h"
#include "escwyp_main_gui_elm_extern.h"
#include "escwyp_main.h"
#include <stdio.h>

int klavierInitGui()
{

   klavier_box = elm_box_add(win);
   evas_object_size_hint_weight_set(klavier_box, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   evas_object_size_hint_align_set(klavier_box, 0.0, 0.5);
   //evas_object_size_hint_align_set(klavier_box, EVAS_HINT_FILL, EVAS_HINT_FILL);
   elm_box_horizontal_set(klavier_box, EINA_TRUE);
   //elm_box_align_set(klavier_box, 0.1, 0.5);
   evas_object_show(klavier_box);

   // the ckeck-box setting piano (0) or accumulator (1) mode for the klavier
//   klavier_mode_check =  elm_check_add(klavier_box);
//   elm_check_state_set(klavier_mode_check, EINA_FALSE);
//   elm_object_part_text_set(klavier_mode_check, NULL, "polymode");
//   evas_object_smart_callback_add(klavier_mode_check, "changed", klavier_mode_check_fun, NULL);    
//   evas_object_show(klavier_mode_check);
//
//   // the ckeck-box setting set freq through piano (0) or ignore piano freq (1) mode for the klavier
//   klavier_ignore_freq_check =  elm_check_add(klavier_box);
//   elm_check_state_set(klavier_ignore_freq_check, EINA_FALSE);
//   elm_object_part_text_set(klavier_ignore_freq_check, NULL, "ignore freqs");
//   evas_object_smart_callback_add(klavier_ignore_freq_check, "changed", klavier_ignore_freq_check_fun, NULL);
//   evas_object_show(klavier_ignore_freq_check);

   // Experimental Klavier
   btn_mul2 = elm_button_add(win);
   elm_theme_extension_add(NULL, "./mulbu.edj");
   elm_object_style_set(btn_mul2, "mulbutt");
   //evas_object_size_hint_weight_set(btn_mul2, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   evas_object_size_hint_align_set(btn_mul2, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //elm_object_text_set(btn_mul2, "Mul");
   elm_object_signal_callback_add(btn_mul2, "igi", "*butt*",  btn_mul_down_fun, NULL);
   elm_object_signal_callback_add(btn_mul2, "igj", "*butt*",  btn_mul_up_fun, NULL);
   elm_object_signal_callback_add(btn_mul2, "igj", "notone",  btn_mul_notone_fun_on, NULL);
   elm_object_signal_callback_add(btn_mul2, "igi", "notone",  btn_mul_notone_off_fun, NULL);
   evas_object_show(btn_mul2);
   //elm_box_pack_end(klavier_box, btn_mul2);


   init_freqs();


   return 3;
}

void klavier_init_keygrabs()
{
   evas_object_event_callback_add(win, EVAS_CALLBACK_KEY_UP, handle_key_up, NULL);
   evas_object_event_callback_add(win, EVAS_CALLBACK_KEY_DOWN, handle_key_down, NULL);

   evas_object_focus_set(win, EINA_TRUE);
   int keygrab = 0;

   keygrab = evas_object_key_grab(win, "q", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "w", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "e", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "r", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "t", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "z", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "u", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "i", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "o", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "p", 0, 0, EINA_TRUE);

   keygrab = evas_object_key_grab(win, "a", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "s", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "d", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "f", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "g", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "h", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "j", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "k", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "l", 0, 0, EINA_TRUE);

   keygrab = evas_object_key_grab(win, "y", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "x", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "c", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "v", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "b", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "n", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "m", 0, 0, EINA_TRUE);

   Evas *the_evas = evas_object_evas_get(win);
   Evas_Modifier_Mask mod_mask = evas_key_modifier_mask_get(the_evas, "Shift");
   keygrab = evas_object_key_grab(win, "q", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "w", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "e", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "r", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "t", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "z", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "u", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "i", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "o", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "p", mod_mask, 0, EINA_TRUE);

   keygrab = evas_object_key_grab(win, "a", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "s", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "d", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "f", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "g", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "h", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "j", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "k", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "l", mod_mask, 0, EINA_TRUE);

   keygrab = evas_object_key_grab(win, "y", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "x", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "c", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "v", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "b", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "n", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "m", mod_mask, 0, EINA_TRUE);

}

void klavierGuiPostbox(Evas_Object **obj_arr)
{
 
   obj_arr[0] = btn_mul2;
   obj_arr[1] = klavier_mode_check;
   obj_arr[2] = klavier_ignore_freq_check;

}


float klavierGetMaxFreq()
{

    return klavier_max_freq;

}
int klavierGetMaxFreqIndex()
{

    return klavier_max_freq_index;

}

float klavierGetMinFreq()
{

    return klavier_min_freq;

}
int klavierGetMinFreqIndex()
{

    return klavier_min_freq_index;

}

int klavierGetIgnoreMode()
{

    return the_klavier_ignore_mode;

}

void init_freqs(){

   int i;
   int mult_fact = 1;
   for(i = 0; i < klavier_max_freq_array_size; ++i){
      if( !(i%12) && i){
         mult_fact <<= 1;
      }
      freqs_by_index[i] = mult_fact*octave_freqs[i%12];
      //fprintf(stdout, "F %f\n", freqs_by_index[i]);
   }
   klavier_min_freq = freqs_by_index[0];
   klavier_max_freq = freqs_by_index[klavier_max_freq_index];
}

static void klavier_mode_check_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis klavier_mode_check_fun\n");
   the_klavier_mode = elm_check_state_get(obj);
   if(the_klavier_mode == 0){
      clear_notes();
      clear_all_btns();
   }
   fprintf(stdout, "KLAVIER MODE %i\n", the_klavier_mode);
}

static void klavier_ignore_freq_check_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis klavier_ignore_freq_check_fun\n");
   the_klavier_ignore_mode = elm_check_state_get(obj);
   if(the_klavier_ignore_mode == 0){
	   release_klavier_control(0);  
   }else{
	   release_klavier_control(1);  
   }
	
   fprintf(stdout, "KLAVIER IGNORE MODE %i\n", the_klavier_ignore_mode);
}

static void clear_all_btns()
{


}



// For Keyboard input


static void handle_key_up(void *data EINA_UNUSED, Evas *evas, Evas_Object *o EINA_UNUSED, void *einfo){

    const Evas_Modifier *mods;
    Evas_Event_Key_Down *ev = einfo;
    //fprintf(stdout, "We've got key input: %s\n", ev->key);
    if (strcmp(ev->key, "y") == 0 || strcmp(ev->key, "Y") == 0){
        note_off(18);
        note_off(30);
    }
    if (strcmp(ev->key, "x") == 0 || strcmp(ev->key, "X") == 0){
        note_off(19);
        note_off(31);
    }
    if (strcmp(ev->key, "c") == 0 || strcmp(ev->key, "C") == 0){
        note_off(20);
        note_off(32);
    }
    if (strcmp(ev->key, "v") == 0 || strcmp(ev->key, "V") == 0){
        note_off(21);
        note_off(33);
    }
    if (strcmp(ev->key, "b") == 0 || strcmp(ev->key, "B") == 0){
        note_off(22);
        note_off(34);
    }
    if (strcmp(ev->key, "n") == 0 || strcmp(ev->key, "N") == 0){
        note_off(23);
        note_off(35);
    }
    if (strcmp(ev->key, "m") == 0 || strcmp(ev->key, "M") == 0){
        note_off(24);
        note_off(36);
    }
    if (strcmp(ev->key, "a") == 0 || strcmp(ev->key, "A") == 0){
        note_off(25);
        note_off(37);
    }
    if (strcmp(ev->key, "s") == 0 || strcmp(ev->key, "S") == 0){
        note_off(26);
        note_off(38);
    }
    if (strcmp(ev->key, "d") == 0 || strcmp(ev->key, "D") == 0){
        note_off(27);
        note_off(39);
    }
    if (strcmp(ev->key, "f") == 0 || strcmp(ev->key, "F") == 0){
        note_off(28);
        note_off(40);
    }
    if (strcmp(ev->key, "g") == 0 || strcmp(ev->key, "G") == 0){
        note_off(29);
        note_off(41);
    }
    if (strcmp(ev->key, "h") == 0 || strcmp(ev->key, "H") == 0){
        note_off(42);
        note_off(56);
    }
    if (strcmp(ev->key, "j") == 0 || strcmp(ev->key, "J") == 0){
        note_off(43);
        note_off(57);
    }
    if (strcmp(ev->key, "k") == 0 || strcmp(ev->key, "K") == 0){
        note_off(44);
        note_off(58);
    }
    if (strcmp(ev->key, "l") == 0 || strcmp(ev->key, "L") == 0){
        note_off(45);
        note_off(59);
    }
    if (strcmp(ev->key, "q") == 0 || strcmp(ev->key, "Q") == 0){
        note_off(46);
        note_off(60);
    }
    if (strcmp(ev->key, "w") == 0 || strcmp(ev->key, "W") == 0){
        note_off(47);
        note_off(61);
    }
    if (strcmp(ev->key, "e") == 0 || strcmp(ev->key, "E") == 0){
        note_off(48);
        note_off(62);
    }
    if (strcmp(ev->key, "r") == 0 || strcmp(ev->key, "R") == 0){
        note_off(49);
        note_off(63);
    }
    if (strcmp(ev->key, "t") == 0 || strcmp(ev->key, "T") == 0){
        note_off(50);
        note_off(64);
    }
    if (strcmp(ev->key, "z") == 0 || strcmp(ev->key, "Z") == 0){
        note_off(51);
        note_off(65);
    }
    if (strcmp(ev->key, "u") == 0 || strcmp(ev->key, "U") == 0){
        note_off(52);
        note_off(66);
    }
    if (strcmp(ev->key, "i") == 0 || strcmp(ev->key, "I") == 0){
        note_off(53);
        note_off(67);
    }
    if (strcmp(ev->key, "o") == 0 || strcmp(ev->key, "O") == 0){
        note_off(54);
        note_off(68);
    }
    if (strcmp(ev->key, "p") == 0 || strcmp(ev->key, "P") == 0){
        note_off(55);
        note_off(69);
    }
    return;
}

static void handle_key_down(void *data EINA_UNUSED, Evas *evas, Evas_Object *o EINA_UNUSED, void *einfo){

    const Evas_Modifier *mods;
    Evas_Event_Key_Down *ev = einfo;
    //fprintf(stdout, "We've got key input: %s\n", ev->key);
    if (strcmp(ev->key, "Y") == 0){
        note_on(18);
    }
    if (strcmp(ev->key, "X") == 0){
        note_on(19);
    }
    if (strcmp(ev->key, "C") == 0){
        note_on(20);
    }
    if (strcmp(ev->key, "V") == 0){
        note_on(21);
    }
    if (strcmp(ev->key, "B") == 0){
        note_on(22);
    }
    if (strcmp(ev->key, "N") == 0){
        note_on(23);
    }
    if (strcmp(ev->key, "M") == 0){
        note_on(24);
    }
    if (strcmp(ev->key, "A") == 0){
        note_on(25);
    }
    if (strcmp(ev->key, "S") == 0){
        note_on(26);
    }
    if (strcmp(ev->key, "D") == 0){
        note_on(27);
    }
    if (strcmp(ev->key, "F") == 0){
        note_on(28);
    }
    if (strcmp(ev->key, "G") == 0){
        note_on(29);
    }

    if (strcmp(ev->key, "y") == 0){
        note_on(30);
    }
    if (strcmp(ev->key, "x") == 0){
        note_on(31);
    }
    if (strcmp(ev->key, "c") == 0){
        note_on(32);
    }
    if (strcmp(ev->key, "v") == 0){
        note_on(33);
    }
    if (strcmp(ev->key, "b") == 0){
        note_on(34);
    }
    if (strcmp(ev->key, "n") == 0){
        note_on(35);
    }
    if (strcmp(ev->key, "m") == 0){
        note_on(36);
    }
    if (strcmp(ev->key, "a") == 0){
        note_on(37);
    }
    if (strcmp(ev->key, "s") == 0){
        note_on(38);
    }
    if (strcmp(ev->key, "d") == 0){
        note_on(39);
    }
    if (strcmp(ev->key, "f") == 0){
        note_on(40);
    }
    if (strcmp(ev->key, "g") == 0){
        note_on(41);
    }
    if (strcmp(ev->key, "h") == 0){
        note_on(42);
    }
    if (strcmp(ev->key, "j") == 0){
        note_on(43);
    }
    if (strcmp(ev->key, "k") == 0){
        note_on(44);
    }
    if (strcmp(ev->key, "l") == 0){
        note_on(45);
    }
    if (strcmp(ev->key, "q") == 0){
        note_on(46);
    }
    if (strcmp(ev->key, "w") == 0){
        note_on(47);
    }
    if (strcmp(ev->key, "e") == 0){
        note_on(48);
    }
    if (strcmp(ev->key, "r") == 0){
        note_on(49);
    }
    if (strcmp(ev->key, "t") == 0){
        note_on(50);
    }
    if (strcmp(ev->key, "z") == 0){
        note_on(51);
    }
    if (strcmp(ev->key, "u") == 0){
        note_on(52);
    }
    if (strcmp(ev->key, "i") == 0){
        note_on(53);
    }
    if (strcmp(ev->key, "o") == 0){
        note_on(54);
    }
    if (strcmp(ev->key, "p") == 0){
        note_on(55);
    }
    if (strcmp(ev->key, "H") == 0){
        note_on(56);
    }
    if (strcmp(ev->key, "J") == 0){
        note_on(57);
    }
    if (strcmp(ev->key, "K") == 0){
        note_on(58);
    }
    if (strcmp(ev->key, "L") == 0){
        note_on(59);
    }
    if (strcmp(ev->key, "Q") == 0){
        note_on(60);
    }
    if (strcmp(ev->key, "W") == 0){
        note_on(61);
    }
    if (strcmp(ev->key, "E") == 0){
        note_on(62);
    }
    if (strcmp(ev->key, "R") == 0){
        note_on(63);
    }
    if (strcmp(ev->key, "T") == 0){
        note_on(64);
    }
    if (strcmp(ev->key, "Z") == 0){
        note_on(65);
    }
    if (strcmp(ev->key, "U") == 0){
        note_on(66);
    }
    if (strcmp(ev->key, "I") == 0){
        note_on(67);
    }
    if (strcmp(ev->key, "O") == 0){
        note_on(68);
    }
    if (strcmp(ev->key, "P") == 0){
        note_on(69);
    }

    return;
}

static void btn_mul_down_fun(void *data, Evas_Object *obj, const char *emission, const char *source)
{
   int val = 0;
   sscanf(source, "butt%x", &val);
   fprintf(stdout, "Yis Mul Down from %s [%i]\n", source, val);
   note_on(val+2);
}
static void btn_mul_up_fun(void *data, Evas_Object *obj, const char *emission, const char *source)
{
   int val = 0;
   sscanf(source, "butt%x", &val);
   fprintf(stdout, "Yis Mul Up from %s [%i]\n", source, val);
   note_off(val+2);
}
static void btn_mul_notone_fun_on(void *data, Evas_Object *obj, const char *emission, const char *source)
{
   fprintf(stdout, "Yis Mul Notone On from %s \n", source);
   release_klavier_control(1);  
}

static void btn_mul_notone_off_fun(void *data, Evas_Object *obj, const char *emission, const char *source)
{
   fprintf(stdout, "Yis Mul Notone Off from %s \n", source);
   release_klavier_control(0);  
}
