// Copyright 2015, Jean Rene Dawin
//
// This Program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.

#include "escwyp_misch_gui_elm.h"
#include "escwyp_misch_extern.h"
#include "escwyp_main_gui_elm_extern.h"
#include "random_aux.h"
#include <Elementary.h>

int mischInitGuiElm(){

   elm_theme_extension_add(NULL, "./slider2.edj");
   // the slider associated with the mix_volume
   misch_vol_slider = elm_slider_add(win);
   elm_object_style_set(misch_vol_slider, "knob_volume");
   //elm_object_style_set(misch_vol_slider, "defaultie");
   //evas_object_size_hint_align_set(misch_vol_slider, EVAS_HINT_FILL, 0.5);
   //evas_object_size_hint_weight_set(misch_vol_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   elm_slider_horizontal_set(misch_vol_slider, EINA_TRUE);
   elm_slider_unit_format_set(misch_vol_slider, "%1.2f vol");
   elm_slider_indicator_show_set(misch_vol_slider, EINA_TRUE);
   elm_slider_min_max_set(misch_vol_slider, 0.0, 1.5);
   //elm_slider_value_set(misch_vol_slider, get_mix_volume());
   elm_slider_span_size_set(misch_vol_slider, 80);
   evas_object_smart_callback_add(misch_vol_slider, "delay,changed", misch_vol_slider_fun, NULL);    
   //double bla = 2.0;
   //elm_slider_value_set(misch_vol_slider, bla);
   elm_slider_value_set(misch_vol_slider, get_mix_volume());
   evas_object_show(misch_vol_slider);

   return 1;

}

void mischGuiElmPostbox(Evas_Object **obj_arr)
{
 
   obj_arr[0] = misch_vol_slider;
}

static void misch_vol_slider_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis misch_vol_slider_fun\n");
   float tmp_volume = (float) elm_slider_value_get(obj);
   set_mix_volume(tmp_volume);
   fprintf(stdout, "new misch volume %f\n", get_mix_volume());

}

void mischGuiElmSetMischVolSlider(double d)
{
   //set_mix_volume((float) d);
   elm_slider_value_set(misch_vol_slider, d);
   misch_vol_slider_fun(NULL, misch_vol_slider, NULL);
}


