// Copyright 2015, Jean Rene Dawin
//
// This Program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.

#include <Elementary.h>
#include <math.h>
//#include "escwyp_distribs_extern.h"
#include "escwyp_oszillo.h"
#include "escwyp_misch_extern.h"
#include "escwyp_line_draw.h"
#include "escwyp_main_gui_elm_extern.h"

int oszilloInitGui()
{

   //// the box containing all of the following
   //oszillo_base_box = elm_box_add(win);
   ////evas_object_size_hint_weight_set(box2, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   ////evas_object_size_hint_align_set(box2, EVAS_HINT_FILL, EVAS_HINT_FILL);
   ////elm_box_align_set(box2, 0.5, 0.0);
   ////elm_box_horizontal_set(oszillo_base_box, EINA_TRUE);
   //elm_box_pack_end(box, oszillo_base_box);
   //evas_object_show(oszillo_base_box);

   canv = evas_object_evas_get(win);
   //ee = ecore_evas_new(NULL, 0, 0, distrib_image_width, distrib_image_height, NULL);
   //ecore_evas_size_min_set(ee, distrib_image_width, distrib_image_height);
   //ecore_evas_size_max_set(ee, distrib_image_width, distrib_image_height);
   //ecore_evas_show(ee);
   //canv = ecore_evas_get(ee);

   //----


   //----
   int k, m;

   pixels = malloc(sizeof(unsigned int)*im_width*im_height); 
   for(k = 0; k < im_width*im_height; k++){

      pixels[k] = 0xFFFFFFFF;
      //fprintf(stdout, "%x, ", pixels[i]);

   }

   pixels_base = malloc(sizeof(unsigned int)*im_width*im_height);
   unsigned int lasttwo;
   for(k = 0; k < im_height; k++){
      lasttwo = (unsigned int) roundf(255.0*k/im_height);
      for(m = 0; m < im_width; m++){

         pixels_base[k*im_width+m] = 0xFF258300+lasttwo;
         pixels[k*im_width+m] = 0xFF258300+lasttwo;

      }
   }
   gen_escwyp(font_size[0], font_size[0], 50, 50);

   pixels_dirty = malloc(sizeof(int)*im_width*2);
   int middle = im_height/2;
   for(k = 0; k < im_width*2; k++){
      pixels_dirty[k] = middle;
   }

   // the image to be shown after start up in the image-scroller below
   im = evas_object_image_add(canv);

   evas_object_image_alpha_set(im, EINA_TRUE);
   evas_object_image_size_set(im, im_width, im_height);
   evas_object_image_data_set(im, pixels);
   //evas_object_image_file_set(im, "escwtiny.png", NULL);
   evas_object_image_colorspace_set(im, EVAS_COLORSPACE_ARGB8888);
   evas_object_image_fill_set(im, 0, 0, im_width, im_height);
   evas_object_image_filled_set(im, EINA_TRUE);
   evas_object_resize(im, im_width, im_height);
   evas_object_size_hint_max_set(im, im_width, im_height);
   evas_object_size_hint_min_set(im, im_width, im_height);
   evas_object_size_hint_weight_set(im, 0.0, 0.0);
   evas_object_size_hint_align_set(im, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //evas_object_color_set(im, 0, 128, 30, 200); /* 50% opaque green */
   //elm_box_pack_end(distrib_base_box, im);
   //elm_table_pack(im_table, im, 1, 1, 3, 3);
   //elm_box_pack_end(box, im);
   evas_object_show(im);
   //elm_box_pack_end(exper_box, im);
   //elm_table_pack(im_table, exper_box, 1, 1, 3, 3);

   fprintf(stdout, "h b b b\n");

   oszillo_timer = ecore_timer_add(0.25, oszillo_func, NULL);
   //ecore_animator_add(oszillo_func, NULL);
   //ecore_animator_frametime_set(0.033);

   // the slider associated with the pixels_group_size
   oszillo_resolution_slider = elm_slider_add(win);
   evas_object_size_hint_align_set(oszillo_resolution_slider, EVAS_HINT_FILL, 0.5);
   evas_object_size_hint_weight_set(oszillo_resolution_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   elm_slider_unit_format_set(oszillo_resolution_slider, "%1.0f resol");
   elm_slider_indicator_show_set(oszillo_resolution_slider, EINA_FALSE);
   elm_slider_min_max_set(oszillo_resolution_slider, 1, 16);
   elm_slider_value_set(oszillo_resolution_slider, get_pixels_group_size());
   elm_slider_span_size_set(oszillo_resolution_slider, 80);
   evas_object_smart_callback_add(oszillo_resolution_slider, "delay,changed", oszillo_resolution_slider_fun, NULL);    
   evas_object_show(oszillo_resolution_slider);

   return 2;
}

void oszilloInitSem()
{

   sem_init(&copy_sem, 0, 0);

}

void oszilloInitBuffer(const int size)
{

   osz_b = (float *) malloc(size*sizeof(float));
   bs = size;
}

void oszilloGuiPostbox(Evas_Object **obj_arr)
{
 
   obj_arr[0] = im;
   obj_arr[1] = oszillo_resolution_slider;

}

Eina_Bool oszillo_func(void *data) {
    if(get_playing_status() == 1){
           int semv = -1;
           sem_getvalue(&copy_sem, &semv);
           if(semv == 1){
                 makeOszilloskopScaled();
	         int sr_copy = sem_wait(&copy_sem);
	   }else{
              fprintf(stdout, "PUFFER bp\n");
           }
        //fprintf(stdout, "oscoscosc\n");
    }else{
        if(schweif == 9){
            int k;
            for(k = 0; k < im_height*im_width; k++){
                pixels[k] = pixels_base[k];
            }
            //evas_object_image_data_update_add(im, 0, 0, im_width, im_height);
            ++schweif;
        }
        if(schweif < 9){
            if(schweif < 7){
                int k;
                for(k = 0; k < im_height*im_width; k++){
                    pixels[k] = pixels_base[k];
                }
            }
            gen_escwyp(font_size[schweif%3], font_size[schweif%3], 50+(schweif%3)*300, 50);
            evas_object_image_data_update_add(im, 0, 0, im_width, im_height);
            ++schweif;
        }
    
        int semv = -1;
        sem_getvalue(&copy_sem, &semv);
        if(semv == 1){
	      int sr_copy = sem_wait(&copy_sem);
	}
        //fprintf(stdout, "escwescwescw\n");
    }
        
    //makeOszilloskop();
    return ECORE_CALLBACK_RENEW;
}

void oszillo_set_schweif(const int value)
{

    schweif = value;

}

void makeOszilloskop(){

   //float startTime = (float) clock()/CLOCKS_PER_SEC;
   int i;
   int out_pixel;

   int j;

   int k;
   //for(i = 0; i < im_width; i++){ 
   //}
   //unsigned int lasttwo;
   //for(i = 0; i < im_height; i++){
   //   lasttwo = (unsigned int) roundf(255.0*i/im_height);
   //   for(j = 0; j < im_width; j++){

   //      pixels[i*im_width+j] = 0xFF258300+lasttwo;

   //   }
   //}
   //int out_pixel;
   //int prev_min = im_height;
   //int prev_max = im_height;
   int caught;

   // for the first (0th) Pixel
   int prev_min = im_height/2;
   int prev_max = im_height/2;
   for(k = pixels_dirty[0]; k < pixels_dirty[1] + 1; k++){
      pixels[k*im_width] = pixels_base[k*im_width];
   }
   out_pixel = (int) roundf(im_height/3.0 * osz_b[0]) + im_height/2;;
   if(out_pixel >= 0 && out_pixel < im_height){
      pixels[out_pixel*im_width] = 0xFFFFFFFF;
      prev_min = out_pixel;
      prev_max = out_pixel;
   }else{
      prev_min = out_pixel < 0 ? 0 : im_height-1;
      prev_max = prev_min;
      pixels[prev_min*im_width] = 0xFFFFFFFF;
   } 
   pixels_dirty[0] = (int) prev_min;
   pixels_dirty[1] = (int) prev_max;

   for(i = 1; i < im_width; i++){
      for(k = pixels_dirty[i*2]; k < pixels_dirty[i*2+1] + 1; k++){
         pixels[k*im_width+i] = pixels_base[k*im_width+i];
      }
      //out_pixel = out_pixels[i];
      out_pixel = (int) roundf(im_height/3.0 * osz_b[i]) + im_height/2;
      if(out_pixel < 0 || out_pixel >= im_height){
         //fprintf(stdout, "TOOHIGH %i\n", out_pixel);
         out_pixel = out_pixel < 0 ? 0 : im_height-1;
         //fprintf(stdout, "OK %i\n", out_pixel);
      } 
      caught = 0;
      if(out_pixel > prev_max){
         for(j = prev_max+1; j < out_pixel; j++){ 
            pixels[j*im_width+i] = 0xFFFFFFFF;
         }
         //pixels[out_pixel*im_width+i] = 0xFFCC2222;
         pixels[out_pixel*im_width+i] = 0xFFFFFFFF;
         prev_min = prev_max+1;
         prev_max = out_pixel;
         caught = 1;
      }
      if(out_pixel < prev_min && !caught){
         for(j = prev_min-1; j > out_pixel; j--){ 
            pixels[j*im_width+i] = 0xFFFFFFFF;
         }
         //pixels[out_pixel*im_width+i] = 0xFFCC2222;
         pixels[out_pixel*im_width+i] = 0xFFFFFFFF;
         prev_max = prev_min-1;
         prev_min = out_pixel;
         caught = 1;
      }
      if(caught == 0){
         //pixels[out_pixel*im_width+i] = 0xFFCC2222;
         pixels[out_pixel*im_width+i] = 0xFFFFFFFF;
         prev_max = out_pixel;
         prev_min = out_pixel;
      } 
      pixels_dirty[i*2] = (int) prev_min;
      pixels_dirty[i*2+1] = (int) prev_max;
      //fprintf(stdout, "%i(%f), ", out_pixel, tmp_sound_buff[i]);
   }
   //fprintf(stdout, "HIER? \n");
   //float endTime = (float) clock()/CLOCKS_PER_SEC;
   //fprintf(stdout, "Pixels Time: %f ... ", endTime-startTime);

   evas_object_image_data_update_add(im, 0, 0, im_width, im_height);

}

void makeOszilloskopScaled(){

   int i;
   int out_pixel;
   int curr_index = 0;
   int j;
   int k;
   int caught;
   int over_color = 0xAAFF2244;
   int coloradd = 0x00111111;

   // for the first (0th) Pixel
   int prev_min = im_height/2;
   int prev_max = im_height/2;

   if(pict_count >= im_width-im_width/pixels_group_size){
      pict_count = 0;
   }

   for(k = pixels_dirty[0]; k < pixels_dirty[1] + 1; k++){
      pixels[k*im_width] = pixels_base[k*im_width];
   }
   if(over > 0){
      for(j = 0; j < 20; ++j){
         for(k = 0; k < 20; ++k){
            pixels[j*im_width+k] -= coloradd;
         }
      }
      over--;
      fprintf(stdout, "PIX %i %x\n", over, pixels[0]);
   }else{
      for(j = 0; j < 20; ++j){
         for(k = 0; k < 20; ++k){
            pixels[j*im_width+k] = pixels_base[j*im_width+k];
         }
      }
      over = 0;
   }

   curr_index = theMaxAbsVal(0, pixels_group_size, osz_b);
   num_pixels_drawn = 1;
   ++pict_count;

   out_pixel = (int) roundf(im_height/3.0 * osz_b[curr_index]) + im_height/2;;
   if(out_pixel >= 0 && out_pixel < im_height){
      pixels[out_pixel*im_width] = 0xFFFFFFFF;
      prev_min = out_pixel;
      prev_max = out_pixel;
   }else{
      prev_min = out_pixel < 0 ? 0 : im_height-1;
      prev_max = prev_min;
      pixels[prev_min*im_width] = 0xFFFFFFFF;
   } 
   pixels_dirty[0] = (int) prev_min;
   pixels_dirty[1] = (int) prev_max;

   for(i = pict_count; i < pict_count+im_width/pixels_group_size-1; ++i){
      for(k = pixels_dirty[i*2]; k < pixels_dirty[i*2+1] + 1; k++){
         pixels[k*im_width+i] = pixels_base[k*im_width+i];
      }
      //out_pixel = out_pixels[i];
      curr_index = theMaxAbsVal(num_pixels_drawn*pixels_group_size, pixels_group_size, osz_b);
      ++num_pixels_drawn;

      out_pixel = (int) roundf(im_height/3.0 * osz_b[curr_index]) + im_height/2;
      if(out_pixel < 0 || out_pixel >= im_height){
         //fprintf(stdout, "TOOHIGH %i\n", out_pixel);
         out_pixel = out_pixel < 0 ? 0 : im_height-1;
         int row = 0;
         for(row = 0; row < 20; ++row){
            int col = 0;
            for(col = 0; col < 20; ++col){
               pixels[row*im_width+col] = over_color;
            }
         }
         over = 8;
         //fprintf(stdout, "OK %i %i\n", over, out_pixel);
      } 
      caught = 0;
      if(out_pixel > prev_max){
         for(j = prev_max+1; j < out_pixel; j++){ 
            pixels[j*im_width+i] = 0xFFFFFFFF;
         }
         //pixels[out_pixel*im_width+i] = 0xFFCC2222;
         pixels[out_pixel*im_width+i] = 0xFFFFFFFF;
         prev_min = prev_max+1;
         prev_max = out_pixel;
         caught = 1;
      }
      if(out_pixel < prev_min && !caught){
         for(j = prev_min-1; j > out_pixel; j--){ 
            pixels[j*im_width+i] = 0xFFFFFFFF;
         }
         //pixels[out_pixel*im_width+i] = 0xFFCC2222;
         pixels[out_pixel*im_width+i] = 0xFFFFFFFF;
         prev_max = prev_min-1;
         prev_min = out_pixel;
         caught = 1;
      }
      if(caught == 0){
         //pixels[out_pixel*im_width+i] = 0xFFCC2222;
         pixels[out_pixel*im_width+i] = 0xFFFFFFFF;
         prev_max = out_pixel;
         prev_min = out_pixel;
      } 
      pixels_dirty[i*2] = (int) prev_min;
      pixels_dirty[i*2+1] = (int) prev_max;
      //fprintf(stdout, "%i(%f), ", out_pixel, tmp_sound_buff[i]);
   }
   pict_count = i-1;
   
   //fprintf(stdout, "HIER? \n");
   //float endTime = (float) clock()/CLOCKS_PER_SEC;
   //fprintf(stdout, "Pixels Time: %f ... ", endTime-startTime);

   evas_object_image_data_update_add(im, 0, 0, im_width, im_height);

}

int theMaxAbsVal(const int start, const int size, const float *data){

   float the_max = 0.0;
   float the_current = 0.0;
   int the_index = start;
   int i;
   for(i = start; i < start+size; ++i){
      the_current = fabs(data[i]);
      if(the_current > the_max){
         the_max = the_current;
         the_index = i;
      }
   }
   return the_index;   

}

static void oszillo_resolution_slider_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis oszillo_resolution_slider_fun\n");
   int tmp_size = (int) roundf(elm_slider_value_get(obj));
   set_pixels_group_size(tmp_size);
   fprintf(stdout, "new pixels_group_size %i\n", get_pixels_group_size());

}
int get_pixels_group_size(){

   return pixels_group_size;

}
void set_pixels_group_size(const int a_size){

   if(a_size >= 1 && a_size <= 256){
      pixels_group_size = a_size;
   }else{
      fprintf(stdout, "bad try to set pixels_group_size  (%i)\n", a_size);
   }

}

//void makeOszilloskopDetail(){
//
//
//   int i;
//   int im_w = 2048;
//   int im_h = 200;
//   int out_pixel;
//
//   //for(i = 0; i < im_w; i++){
//   //   out_pixels[i] = 0;
//   //}
//
//   //Evas_Object *polyfu;
//   // polyfu = evas_object_polygon_add(canv);
//   // //elm_image_resizable_set(polyfu, EINA_TRUE, EINA_FALSE);
//   // evas_object_size_hint_weight_set(polyfu, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
//   // evas_object_size_hint_align_set(polyfu, EVAS_HINT_FILL, EVAS_HINT_FILL);
//
//
//   float summ = 0.0;
//   ImlibPolygon thepoly = imlib_polygon_new(); 
//   for (i = 0; i < im_w; i++){
//      if(distrib_maximum > 0.0){
//         out_pixel = (int) roundf(im_h/3.0 * distribs_get_distrib(i)/distrib_maximum) + im_h/2;
//         summ += distribs_get_distrib(i);
//         //out_pixel = (int) roundf(im_h/3.0 * distribs_get_dist_marks(i)) + im_h/2;
//         if(distribs_get_distrib(i) >= distrib_maximum/100){
//            fprintf(stdout, "DIST %i: %f, out_p: %i summ: %f\n", i, distribs_get_distrib(i), out_pixel, summ);
//         }else{
//            fprintf(stdout, "DIST %i: %f, summ: %f\n", i, distribs_get_distrib(i), summ);
//         }
//      }
//      imlib_polygon_add_point(thepoly, i, out_pixel);
//      ////evas_object_polygon_point_add(polyfu, i+5, out_pixel+5);
//
//      //fprintf(stdout, "Jeee %i %i \n", i, out_pixels[i]);
//      //imlib_polygon_add_point(thepoly, i, 15);
//      //fprintf(stdout, "%i %i\n", i, konta[i]);
//   }
//   //for (i = im_w-1; i >= 0; i--){
//   //   out_pixel = (int) roundf(im_h/3.0 * osz_b[i]) + im_h/2;
//   //   evas_object_polygon_point_add(polyfu, i, out_pixel);
//   //}
//
//   Imlib_Image theim = imlib_create_image(im_w, im_h);
//   imlib_context_set_image(theim);
//   imlib_context_set_color(255, 255, 255, 255);
//   imlib_image_fill_rectangle(0, 0, im_w, im_h);
//   //imlib_context_set_color(55, 155, 100, 255);
//   //imlib_image_fill_polygon(thepoly);
//   imlib_context_set_color(0, 0, 0, 255);
//   imlib_image_draw_polygon(thepoly, 0);
//   imlib_image_set_format("png");
//   imlib_save_image("/tmp/oszillo_image.png");
//
//   Evas_Object *im_oszillo = elm_image_add(win);
//   elm_image_file_set(im_oszillo, "/tmp/oszillo_image.png", NULL);
//   elm_image_resizable_set(im_oszillo, EINA_TRUE, EINA_FALSE);
//   //elm_win_resize_object_add(win, im_oszillo);
//   evas_object_size_hint_weight_set(im_oszillo, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
//   evas_object_size_hint_align_set(im_oszillo, EVAS_HINT_FILL, EVAS_HINT_FILL);
//   evas_object_show(im_oszillo);
//
//   //evas_object_color_set(polyfu, 0, 0, 255, 128); 
//   //evas_object_show(polyfu);
//   //elm_object_content_set(scr, polyfu);
//
//   elm_object_content_set(scr, im_oszillo);
//
//}



static void gen_escwyp(const int w, const int h, const int xoff, const int yoff){

    //int w = 119;
    //int h = 119;
    int trenn = (int) roundf(1.0*w);
    int trenn_accu = xoff;
    //E
    int *gpoints = (int *) malloc(w*h*sizeof(int)); //the Bitmap for graphic output
    int i;
    for(i = 0; i < w*h; ++i){
        gpoints[i] = 0;
    }
	float thepts[4];
    thepts[0] = 0.5;
    thepts[1] = 0.25;
    thepts[2] = 0.2;
    thepts[3] = 0.2;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.3;
    thepts[3] = 0.8;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.3;
    thepts[1] = 0.8;
    thepts[2] = 0.6;
    thepts[3] = 0.9;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.26;
    thepts[1] = 0.53;
    thepts[2] = 0.56;
    thepts[3] = 0.61;
    draw_lines(1, gpoints, thepts, w, h, 0, 0, 0);
    //fprintf(stdout, "---------- > E drawn 000\n");
    draw_escwyp(gpoints, w, h, trenn_accu, 50);
    trenn_accu += trenn;
    //fprintf(stdout, "---------- > E drawn 111\n");
    //
    //S
    for(i = 0; i < w*h; ++i){
        gpoints[i] = 0;
    }
    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.5;
    thepts[3] = 0.25;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.5;
    thepts[1] = 0.25;
    thepts[2] = 0.55;
    thepts[3] = 0.575;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.55;
    thepts[1] = 0.575;
    thepts[2] = 0.25;
    thepts[3] = 0.5;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.25;
    thepts[1] = 0.5;
    thepts[2] = 0.3;
    thepts[3] = 0.8;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.3;
    thepts[1] = 0.8;
    thepts[2] = 0.6;
    thepts[3] = 0.9;
    draw_lines(1, gpoints, thepts, w, h, 0, 0, 0);
    draw_escwyp(gpoints, w, h, trenn_accu, yoff);
    trenn_accu += trenn;
    //fprintf(stdout, "S drawn\n");
    //
    // C
    for(i = 0; i < w*h; ++i){
        gpoints[i] = 0;
    }
    thepts[0] = 0.5;
    thepts[1] = 0.25;
    thepts[2] = 0.2;
    thepts[3] = 0.2;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.3;
    thepts[3] = 0.8;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.3;
    thepts[1] = 0.8;
    thepts[2] = 0.6;
    thepts[3] = 0.9;
    draw_lines(1, gpoints, thepts, w, h, 0, 0, 0);
    draw_escwyp(gpoints, w, h, trenn_accu, yoff);
    trenn_accu += trenn;
    //fprintf(stdout, "C drawn\n");
    //
    //W
    for(i = 0; i < w*h; ++i){
        gpoints[i] = 0;
    }
    thepts[0] = 0.3;
    thepts[1] = 0.8;
    thepts[2] = 0.2;
    thepts[3] = 0.2;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.6;
    thepts[3] = 0.9;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.6;
    thepts[1] = 0.9;
    thepts[2] = 0.5;
    thepts[3] = 0.25;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.5;
    thepts[1] = 0.25;
    thepts[2] = 0.9;
    thepts[3] = 0.95;
    draw_lines(1, gpoints, thepts, w, h, 0, 0, 0);
    draw_escwyp(gpoints, w, h, trenn_accu, yoff);
    trenn_accu += trenn;
    //fprintf(stdout, "W drawn\n");
    //
    //Y
    for(i = 0; i < w*h; ++i){
        gpoints[i] = 0;
    }
    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.6;
    thepts[3] = 0.9;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.45;
    thepts[1] = 0.85;
    thepts[2] = 0.4;
    thepts[3] = 0.55;
    draw_lines(1, gpoints, thepts, w, h, 0, 0, 0);
    draw_escwyp(gpoints, w, h, trenn_accu, yoff);
    trenn_accu += trenn;
    //fprintf(stdout, "Y drawn\n");
    //
    //P
    for(i = 0; i < w*h; ++i){
        gpoints[i] = 0;
    }
    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.3;
    thepts[3] = 0.8;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.3;
    thepts[1] = 0.8;
    thepts[2] = 0.3;
    thepts[3] = 0.8;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.3;
    thepts[1] = 0.8;
    thepts[2] = 0.6;
    thepts[3] = 0.9;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.6;
    thepts[1] = 0.9;
    thepts[2] = 0.56;
    thepts[3] = 0.64;
    draw_lines(0, gpoints, thepts, w, h, 0, 0, 0);

    thepts[0] = 0.56;
    thepts[1] = 0.64;
    thepts[2] = 0.26;
    thepts[3] = 0.56;
    draw_lines(1, gpoints, thepts, w, h, 0, 0, 0);
    draw_escwyp(gpoints, w, h, trenn_accu, yoff);
    trenn_accu += trenn;
    //fprintf(stdout, "P drawn\n");
    free(gpoints);
    //
}

static void draw_escwyp(const int *points, const int width, const int height, const int xoff, const int yoff){

    int i;
    for(i = 0; i < height-1; ++i){
        int j;
        for(j = 0; j < width; ++j){
            int pixel_coord = (yoff+height-i)*im_width+j+xoff;
            if(points[i*width+j] == 1 && pixel_coord < im_width*im_height){
                pixels[pixel_coord] = 0xFFFFFFFF;
            }
        }
    }
    //evas_object_image_data_update_add(im, 0, 0, im_width, im_height);

}

// copy misch_buff to b
void oszilloCopyBuffer(const int mbs, const float *mb)
{
//cpoy
   int semv = -1;
   sem_getvalue(&copy_sem, &semv);
   if(semv == 0){
       //fprintf(stdout, " - - - OSZ-COPY-PUFFER\n");
      // size of the rmeaining free space in b
      int fr = bs - bp;

      // copy size of the data to be copied
      int cs = 0;
      if(fr >= mbs){
         cs = mbs;
      }else{
         cs = fr;
      }
      //fprintf(stdout, "bs=%i mbs=%i OSZ-COPY-PUFFER fr=%i, bp=%i, cs=%i\n", bs, mbs, fr, bp, cs);

      if(cs <= fr){ // this check is not needed I think TODO
         memcpy(osz_b + bp, mb, cs*sizeof(float));
         //fprintf(stdout, " OSZ-COPY-PUFFER ---\n");
      }
      // update buffer position
      bp += cs;
      if(bp >= bs){
         bp = 0;
         sem_post(&copy_sem);
      }
      //fprintf(stdout, " - OSZ-COPY-PUFFER bp=%i\n", bp);
   }else{
      //fprintf(stdout, " - OSZ-COPY-PUFFER bp=%i\n", bp);
   }
}
