// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#include <stdio.h>
//#include <stdlib.h>
#include <sys/select.h>
#include <pthread.h>
#include "escwyp_out_none.h"
#include "escwyp_globals_extern.h"
#include "escwyp_misch_extern.h"
#include "escwyp_out_txt_extern.h"
#include "escwyp_main.h"

// none sound out 

static void *processNone(void *args)
{


	int caught = 0;
	time_t seconds = 0;
	long nanoseconds = 40000000; // 4 millisekunden
	struct timespec the_ts;
	the_ts.tv_sec = seconds;
	the_ts.tv_nsec = nanoseconds;

	while(1){

		//caught = 0;
		//if(buff_leere == 0 && playsth == 0 && oszill_drawn == 0){

		//	fprintf(stdout, "OSZ %i\n", oszillcount); 
		//	buff_leere = 0;
		//	oszill_drawn = 1;
		//	caught = 1;
		//}

		//if(buff_leere == 1 && playsth == 0){
		if(playsth == 0){

			//fprintf(stdout, "F W A R T E = \n"); 
                	pselect(0, NULL, NULL, NULL, &the_ts, NULL);
   			outTxtCopy(sound_buffer_length, wartemal);
			buff_leere = 0;
			//oszill_drawn = 0;
			//caught = 1;
		}

        // Pustet nochmal den buffer durch bevor direkt danach Sound reinkommt
		if(playsth != 0 && buff_leere == 0){

			buff_leere = 1;
		}

		// When sound is going to be precessed we enter here  -------------
		if(playsth != 0){

			//current_sound_function = 1;
			misch(sound_buffer_length);
                	pselect(0, NULL, NULL, NULL, &the_ts, NULL);
   			outTxtCopy(sound_buffer_length, buff_L);
			buff_leere = 2;
			caught = 1;

		}


		if(buff_leere == 2 && playsth < 0){
			//int i;
			//sample_t nframes_fact = 1.0;
			//sample_t nframes_fact_subtract = 1.0;

			//if(nframes > 1){
			//   nframes_fact_subtract = (sample_t) 1.0/(nframes-1);
			//}

			//for(i = 0; i < nframes; i++){
			//   out[i] *= nframes_fact;
			//   nframes_fact -= nframes_fact_subtract;
			//}
			//fprintf(stdout, "E N V E L O P E %i %f fact=%f\n", nframes, out[nframes-1], nframes_fact); 
			misch(sound_buffer_length);
			buff_leere = 1;
			playsth = 0;
			caught = 1;
		}
		//if(!caught){
		//	//fprintf(stdout, "Gecaught.\n");
		//	pselect(0, NULL, NULL, NULL, &the_ts, NULL);
		//}
                int semv = -1;
                sem_getvalue(&stop_sem, &semv);
		if(semv == 0){
		   break;
		}
	}
	sem_post(&stop_sem);
	return args;
}
// -----------------------------

int escwyp_out_none_init()
{

    int reti = -1;
    create_buffers(sound_buffer_length);
    sem_init(&stop_sem, 0, 1);
    //Hier wird der Tread definiert, der processNone() aufruft. Der Thread beendet sich selbst
    //wenn processNone() zurückkehrt. Damit er dabei seine Ressourcen freigibt muss in athred_attr
    //d. h. den Attributen des Threads PTHREAD_CREATE_DETACHED gesetzt werden (man pthread_create).  
    pthread_attr_t none_thread_attr;
    pthread_attr_init(&none_thread_attr);
    pthread_attr_setdetachstate(&none_thread_attr, PTHREAD_CREATE_DETACHED);
    thret = pthread_create(&none_thread, &none_thread_attr, &processNone, &sound_buffer_length);

    if(thret == 0){
       fprintf(stdout, "Ready to not play None.\n");
       reti = 0;
    }else{
       fprintf(stdout, "Faliled to start thread for playing None.\n");
    }

    return reti;

}
int escwyp_out_none_stop()
{
   int reti = 0;
   if(thret == 0){
      fprintf(stdout, "Killing the none thread:\n");
      //pthread_cancel(none_thread);
      int sr_stop = sem_wait(&stop_sem);
      fprintf(stdout, "Killed the none thread Apres premiere stop.\n");
      sr_stop = sem_wait(&stop_sem);
      fprintf(stdout, "Killed the none thread Apres seconde stop.\n");
      sem_destroy(&stop_sem);
      fprintf(stdout, "Killed the none thread.\n");
      reti = 1;
      //TODO: if ptread_cancel cannot kill the thread or takes to long, we won't be noticed
      // and setting thret to -1 might not represent the fact that none_thread is actually sitll alive -> possible problems
      thret = -1;
   } 
   return reti;
}

