#ifndef ESCWYP_OUT_NONE_H
#define ESCWYP_OUT_NONE_H
#include <semaphore.h>


static pthread_t none_thread; 
// the return code of pthread_create
static int thret = -1;

// Semaphore to signal the infinite loop in processNone
// that it should finish.
// Initially stop_sem is set to 1. If it is set to 1
// the loop will break causing the thread to end.
// Shortly before processNone returns, it posts stop_sem to be 1.
// So the code demanding the loop to finish can sem_wait on stop_sem
// and will wake up when the thread has ended. Roughly.
static sem_t stop_sem;

static void *processNone(void *args);
int escwyp_out_none_init();
int escwyp_out_none_stop();

#endif
