// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#include "escwyp_patch_select.h"
#include "escwyp_chain_patch_eet.h"
#include "escwyp_sine_robin_patch_eet.h"
#include "escwyp_sine_grass_patch_eet.h"
#include "escwyp_nadelper_patch_eet.h"
#include "escwyp_samplecast_patch_eet.h"
#include "escwyp_spratz_patch_eet.h"
#include "escwyp_globals_extern_basic.h"


void escwyp_patch_load(Eet_File *ef, const char *id){


    patch_file = ef;

    char glob[255];
    glob[0] = 47;
    glob[1] = 0;
    strcat(glob, "PATCH_NAME/");
    int num_matches = 0;

    switch(current_sound_function){

        case 1: { 
                    strcat(glob, "chain/");
                    strcat(glob, id);
                    char **liste = eet_list(ef, glob, &num_matches);
                    fprintf(stdout, "NUM_MATCHES = %i, %s\n", num_matches, glob);
                    if(num_matches > 0){
                        chain_load_patch(id);
                    }else{
                        fprintf(stdout, "Patch gibts nich.\n");
                    }                
                    if(liste){
                        free(liste);
                    }    
                    break; 
                }
        case 2: { 
                    strcat(glob, "chain/");
                    strcat(glob, id);
                    char **liste = eet_list(ef, glob, &num_matches);
                    fprintf(stdout, "NUM_MATCHES = %i, %s\n", num_matches, glob);
                    if(num_matches > 0){
                        chain_load_patch(id);
                    }else{
                        fprintf(stdout, "Patch gibts nich.\n");
                    }                
                    if(liste){
                        free(liste);
                    }    
                    break; 
                }
        case 3: { 
                    strcat(glob, "sine_robin/");
                    strcat(glob, id);
                    char **liste = eet_list(ef, glob, &num_matches);
                    fprintf(stdout, "NUM_MATCHES = %i, %s\n", num_matches, glob);
                    if(num_matches > 0){
                        sine_robin_load_patch(id);
                    }else{
                        fprintf(stdout, "Patch gibts nich.\n");
                    }                
                    if(liste){
                        free(liste);
                    }    
                    break; 
                }
        case 4: { 
                    strcat(glob, "sine_grass/");
                    strcat(glob, id);
                    char **liste = eet_list(ef, glob, &num_matches);
                    fprintf(stdout, "NUM_MATCHES = %i, %s\n", num_matches, glob);
                    if(num_matches > 0){
                        sine_grass_load_patch(id);
                    }else{
                        fprintf(stdout, "Patch gibts nich.\n");
                    }                
                    if(liste){
                        free(liste);
                    }    
                    break; 
                }
        case 5: { 
                    strcat(glob, "nadelper/");
                    strcat(glob, id);
                    char **liste = eet_list(ef, glob, &num_matches);
                    fprintf(stdout, "NUM_MATCHES = %i, %s\n", num_matches, glob);
                    if(num_matches > 0){
                        nadelper_load_patch(id);
                    }else{
                        fprintf(stdout, "Patch gibts nich.\n");
                    }                
                    if(liste){
                        free(liste);
                    }    
                    break; 
                }
        case 6: { 
                    strcat(glob, "samplecast/");
                    strcat(glob, id);
                    char **liste = eet_list(ef, glob, &num_matches);
                    fprintf(stdout, "NUM_MATCHES = %i, %s\n", num_matches, glob);
                    if(num_matches > 0){
                        samplecast_load_patch(id);
                    }else{
                        fprintf(stdout, "Patch gibts nich.\n");
                    }                
                    if(liste){
                        free(liste);
                    }    
                    break; 
                }
        case 7: { 
                    strcat(glob, "spratz/");
                    strcat(glob, id);
                    char **liste = eet_list(ef, glob, &num_matches);
                    fprintf(stdout, "NUM_MATCHES = %i, %s\n", num_matches, glob);
                    if(num_matches > 0){
                        spratz_load_patch(id);
                    }else{
                        fprintf(stdout, "Patch gibts nich.\n");
                    }                
                    if(liste){
                        free(liste);
                    }    
                    break; 
                }
    }

}

void escwyp_patch_save(Eet_File *ef, const char *id){

    patch_file = ef;

    switch(current_sound_function){

        case 1: { 
                    chain_save_patch(id);                
                    break; 
                }
        case 2: { 
                    chain_save_patch(id);                
                    break; 
                }
        case 3: { 
                    sine_robin_save_patch(id);                
                    break; 
                }
        case 4: { 
                    sine_grass_save_patch(id);                
                    break; 
                }
        case 5: { 
                    nadelper_save_patch(id);                
                    break; 
                }
        case 6: { 
                    samplecast_save_patch(id);                
                    break; 
                }
        case 7: { 
                    spratz_save_patch(id);                
                    break; 
                }

    }

}

void *escwyp_patch_load_param(void *result, const char *name){

    fprintf(stdout, "III aa %s\n", name);
    int size;
    void *result2 = eet_read(patch_file, name, &size);
    result = result2;
    fprintf(stdout, "III bb %i\n ", size);
    //float *vorfakts = (float *) result;
    //int i;
    //fprintf(stdout, "r %x v %x III samplecast_vorfakts = ", result, vorfakts);
    //for(i = 0; i < 10; ++i){
    //    fprintf(stdout, "%f, ", vorfakts[i]);
    //}
    return result2;
    //free(result);
    fprintf(stdout, "III after free vorfakts\n");

}

void escwyp_patch_save_param(const void *stuff, const int size, const char *name){

    eet_write(patch_file, name, stuff, size, 0);

}

void escwyp_eet_open(char *name){

    eet_init();
    patch_file = eet_open("testpatch.eet", EET_FILE_MODE_READ);
    //ERROR_HANDLING !!
    fprintf(stdout, "2 after load_patch\n");

}

void escwyp_eet_close(char *name){

    eet_close(patch_file);
    //ERROR_HANDLING !!
    eet_shutdown();

}

static void escwyp_patch_load_patch(const char *id, const int num_params, const char **params, const int *param_types, const int *param_sizes, const int opts){

	int i;
	for(i = 0; i < num_params; ++i){

		switch(param_types[i]){
			// int
			case 0: {
					
				}
				break;
			// float
			case 1: {
					
				}
				break;
			// char *
			case 2: {
					
				}
				break;
		}
	}


}

