// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#include "escwyp_globals_extern.h"
#include "escwyp_patch_select_gui_elm.h"
#include "escwyp_utils_extern.h"
#include "escwyp_patch_select_extern.h"

void escwypPatchSelectInitGuiElm(Evas_Object *box){

    tabpatch = elm_table_add(win);
    //evas_object_size_hint_weight_set(tabpatch , EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
    //evas_object_size_hint_align_set(tabpatch , EVAS_HINT_FILL, EVAS_HINT_FILL);
    evas_object_size_hint_weight_set(tabpatch , 0.5, 0.5);
    evas_object_size_hint_align_set(tabpatch , -1.0, -1.0);
    elm_box_pack_end(box, tabpatch);
    elm_table_padding_set(tabpatch , 2, 2);
    fprintf(stdout, "EVAS_HINT_FILL = %f, EVAS_HINT_EXPAND = %f\n", EVAS_HINT_FILL, EVAS_HINT_EXPAND);


    gen_patch_name_button = elm_button_add(win);
    elm_object_text_set(gen_patch_name_button, "Gen Patch Name");  
    evas_object_show(gen_patch_name_button);
    evas_object_smart_callback_add(gen_patch_name_button, "clicked", gen_patch_name_button_fun, patch_name_entr);
    elm_table_pack(tabpatch, gen_patch_name_button, 0, 0, 1, 1);

    // the ckeck-box enabling syllable-generation
    gen_syllables_check =  elm_check_add(win);
    elm_check_state_set(gen_syllables_check, EINA_FALSE);
    elm_object_part_text_set(gen_syllables_check, NULL, "Gen syllables!");
    evas_object_smart_callback_add(gen_syllables_check, "changed", gen_syllables_check_fun, NULL);    
    elm_table_pack(tabpatch, gen_syllables_check, 1, 0, 1, 1);
    evas_object_show(gen_syllables_check);

    patch_name_entr = elm_entry_add(win);
    elm_entry_single_line_set(patch_name_entr, EINA_TRUE);
    elm_entry_scrollable_set(patch_name_entr, EINA_TRUE);
    evas_object_size_hint_weight_set(patch_name_entr, EVAS_HINT_EXPAND, 0.0);
    evas_object_size_hint_align_set(patch_name_entr, EVAS_HINT_FILL, EVAS_HINT_FILL);
    evas_object_size_hint_min_set(patch_name_entr, 30, 10);
    //elm_entry_end_visible_set(patch_name_entr, EINA_TRUE);
    //elm_object_part_content_set(patch_name_entr, "end", entr3labl);
    elm_object_part_text_set(patch_name_entr, NULL, "Patch_Name");
    evas_object_smart_callback_add(patch_name_entr, "activated", patch_name_entr_fun, NULL); 
    evas_object_smart_callback_add(patch_name_entr, "clicked", patch_name_entr_fun2, NULL); 
    evas_object_smart_callback_add(patch_name_entr, "unfocused", patch_name_entr_fun3, NULL); 
    elm_table_pack(tabpatch, patch_name_entr, 0, 1, 1, 1);
    evas_object_show(patch_name_entr);
    //elm_entry_selection_handler_disabled_set(patch_name_entr, EINA_FALSE);

    save_patch_button = elm_button_add(win);
    elm_object_text_set(save_patch_button , "Save Patch");  
    //evas_object_size_hint_weight_set(save_patch_button , EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
    //evas_object_size_hint_align_set(save_patch_button , EVAS_HINT_FILL, EVAS_HINT_FILL);
    evas_object_show(save_patch_button);
    evas_object_smart_callback_add(save_patch_button, "clicked", save_patch_button_fun, patch_name_entr);
    elm_table_pack(tabpatch, save_patch_button, 1, 1, 1, 1);


    patch_list = elm_list_add(win);
    //evas_object_size_hint_weight_set(tabpatch , 1.0, 1.0);
    //evas_object_size_hint_align_set(tabpatch , -1.0, -1.0);
    evas_object_size_hint_weight_set(patch_list, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
    evas_object_size_hint_align_set(patch_list, EVAS_HINT_FILL, EVAS_HINT_FILL);
    //evas_object_size_hint_min_set(patch_list, 90, 190);
    evas_object_size_hint_max_set(patch_list, 230, 230);
    elm_list_mode_set(patch_list, ELM_LIST_EXPAND);
    elm_list_go(patch_list);
    elm_table_pack(tabpatch, patch_list, 0, 2, 2, 2);
    evas_object_show(patch_list);
    int une = 1;

    Eet_File *ef;
    eet_init();
    ef = eet_open("testpatch.eet", EET_FILE_MODE_READ_WRITE);

    char glob[255];
    glob[0] = 47;
    glob[1] = 0;
    strcat(glob, "PATCH_NAME/");
    switch(current_sound_function){

        case 1: { 
                    strcat(glob, "chain/*");
                    break; 
                }
        case 2: { 
                    strcat(glob, "chain/*");
                    break; 
                }
        case 3: { 
                    strcat(glob, "sine_robin/*");
                    break; 
                }
        case 4: { 
                    strcat(glob, "sine_grass/*"); 
                    break; 
                }
        case 5: { 
                    strcat(glob, "nadelper/*");
                    break; 
                }
        case 6: { 
                    strcat(glob, "samplecast/*");
                    break; 
                }
        case 7: { 
                    strcat(glob, "spratz/*"); 
                    break; 
                }
    }
    
//    int num_matches = 0;
//    char **liste = eet_list(ef, glob, &num_matches);
//    fprintf(stdout, "NUM_MATCHES = %i, %s\n", num_matches, glob);
//    if(num_matches > 0){
//        fprintf(stdout, "SUPI\n");
//        int une = 1;
//        int i;
//        for(i = 0; i < num_matches; ++i){
//            elm_list_item_append(patch_list, *(liste+i), NULL, NULL, patch_list_fun, &une);
//            fprintf(stdout, "Gee %s\n", *(liste+i));
//        }
//    }else{
//        fprintf(stdout, "NOTTIN\n");
//    }
//        
//    if(liste){
//        free(liste);
//    }    

    eet_close(ef);
    eet_shutdown();

    evas_object_show(tabpatch);
    fprintf(stdout, "Nach PatchGuiInit\n");

}

void strip_name(char *the_name){

    if(the_name){
        int i = 0;
        int j = 0;
        while(i < 255){
            //fprintf(stdout, "str i=%i j=%i len %i\n", i, j, strlen(the_name));
            if(the_name[i] == 0){
                the_name[j] = 0;
                fprintf(stdout, "brk says, is null\n");
                break;
            }
            if(the_name[i] == 47){
                j = 0;
                ++i;
            }else{
                the_name[j] = the_name[i];
                //fprintf(stdout, "strip_name2 i=%i %c j=%i %c\n", i, the_name[i], j, the_name[j]);
                ++j;
                ++i;
            }
            
        }
    }else{
        fprintf(stdout, "strip_name says, is null\n");
    }

}

void escwyp_refresh_patch_selector(){

    char glob[255];
    glob[0] = 47;
    glob[1] = 0;

    switch(current_sound_function){

        case 1: { 
                    strcat(glob, "PATCH_NAME/chain/*");
                    break; 
                }
        case 2: { 
                    strcat(glob, "PATCH_NAME/chain/*");
                    break; 
                }
        case 3: { 
                    strcat(glob, "PATCH_NAME/sine_robin/*");
                    break; 
                }
        case 4: { 
                    strcat(glob, "PATCH_NAME/sine_grass/*"); 
                    break; 
                }
        case 5: { 
                    strcat(glob, "PATCH_NAME/nadelper/*");
                    break; 
                }
        case 6: { 
                    strcat(glob, "PATCH_NAME/samplecast/*"); 
                    break; 
                }
        case 7: { 
                    strcat(glob, "PATCH_NAME/spratz/*"); 
                    break; 
                }

    }

    elm_list_clear(patch_list);
    int num_matches = 0;
    Eet_File *ef;
    eet_init();
    ef = eet_open("testpatch.eet", EET_FILE_MODE_READ_WRITE);
    char **liste = eet_list(ef, glob, &num_matches);
    fprintf(stdout, "NUM_MATCHES = %i, %s\n", num_matches, glob);
    if(num_matches > 0){
        int i;
        for(i = 0; i < num_matches; ++i){
            if(liste){
                fprintf(stdout, "GeeONE %s\n", *(liste+i));
                char glub[255];
                strcpy(glub, *(liste+i));
                strip_name(glub);
                fprintf(stdout, "GeeONEstripped %s\n", glub);
                elm_list_item_append(patch_list, glub, NULL, NULL, patch_list_fun, &i);
                fprintf(stdout, "Gee %s\n", *(liste+i));
            }else{
                fprintf(stdout, "GeeNULL\n");
            }   
        }
    }else{
        fprintf(stdout, "NOTTIN\n");
    }
    if(liste){
        free(liste);
    }    
    eet_close(ef);
    eet_shutdown();
    elm_list_go(patch_list);
    evas_object_show(patch_list);
    evas_object_resize(patch_frame, 100, 400); 
    


}

static void patch_list_fun(void *data, Evas_Object *obj, void *event_info){
    fprintf(stdout, "patch_list_fun\n");

    Elm_Object_Item *item = elm_list_selected_item_get(obj);
    const char *item_text = elm_object_item_part_text_get(item, NULL);
    elm_entry_entry_set(patch_name_entr, item_text);
    fprintf(stdout, "THE ITEM TXT = %s\n", item_text);
    Eet_File *ef;
    eet_init();
    ef = eet_open("testpatch.eet", EET_FILE_MODE_READ_WRITE);
    escwyp_patch_load(ef, item_text);
    eet_sync(ef);
    eet_close(ef);
    eet_shutdown();
    fprintf(stdout, "1 after load_patch\n");

}

static void patch_name_entr_fun(void *data, Evas_Object *obj, void *event_info){
    fprintf(stdout, "patch_name_entr_fun\n");

    const char *entr_text = elm_entry_entry_get(obj);
    fprintf(stdout, "THE ENTRY TXT = %s\n", entr_text);
    do_save_the_patch(entr_text);

}
static void patch_name_entr_fun2(void *data, Evas_Object *obj, void *event_info){
   fprintf(stdout, "patch_name_entr_fun ZWEI\n");

   evas_object_key_ungrab(win, "q", 0, 0);
   evas_object_key_ungrab(win, "w", 0, 0);
   evas_object_key_ungrab(win, "e", 0, 0);
   evas_object_key_ungrab(win, "r", 0, 0);
   evas_object_key_ungrab(win, "t", 0, 0);
   evas_object_key_ungrab(win, "z", 0, 0);
   evas_object_key_ungrab(win, "u", 0, 0);
   evas_object_key_ungrab(win, "i", 0, 0);
   evas_object_key_ungrab(win, "o", 0, 0);
   evas_object_key_ungrab(win, "p", 0, 0);

   evas_object_key_ungrab(win, "a", 0, 0);
   evas_object_key_ungrab(win, "s", 0, 0);
   evas_object_key_ungrab(win, "d", 0, 0);
   evas_object_key_ungrab(win, "f", 0, 0);
   evas_object_key_ungrab(win, "g", 0, 0);
   evas_object_key_ungrab(win, "h", 0, 0);
   evas_object_key_ungrab(win, "j", 0, 0);
   evas_object_key_ungrab(win, "k", 0, 0);
   evas_object_key_ungrab(win, "l", 0, 0);

   evas_object_key_ungrab(win, "y", 0, 0);
   evas_object_key_ungrab(win, "x", 0, 0);
   evas_object_key_ungrab(win, "c", 0, 0);
   evas_object_key_ungrab(win, "v", 0, 0);
   evas_object_key_ungrab(win, "b", 0, 0);
   evas_object_key_ungrab(win, "n", 0, 0);
   evas_object_key_ungrab(win, "m", 0, 0);

   Evas *the_evas = evas_object_evas_get(win);
   Evas_Modifier_Mask mod_mask = evas_key_modifier_mask_get(the_evas, "Shift");
   evas_object_key_ungrab(win, "q", mod_mask, 0);
   evas_object_key_ungrab(win, "w", mod_mask, 0);
   evas_object_key_ungrab(win, "e", mod_mask, 0);
   evas_object_key_ungrab(win, "r", mod_mask, 0);
   evas_object_key_ungrab(win, "t", mod_mask, 0);
   evas_object_key_ungrab(win, "z", mod_mask, 0);
   evas_object_key_ungrab(win, "u", mod_mask, 0);
   evas_object_key_ungrab(win, "i", mod_mask, 0);
   evas_object_key_ungrab(win, "o", mod_mask, 0);
   evas_object_key_ungrab(win, "p", mod_mask, 0);

   evas_object_key_ungrab(win, "a", mod_mask, 0);
   evas_object_key_ungrab(win, "s", mod_mask, 0);
   evas_object_key_ungrab(win, "d", mod_mask, 0);
   evas_object_key_ungrab(win, "f", mod_mask, 0);
   evas_object_key_ungrab(win, "g", mod_mask, 0);
   evas_object_key_ungrab(win, "h", mod_mask, 0);
   evas_object_key_ungrab(win, "j", mod_mask, 0);
   evas_object_key_ungrab(win, "k", mod_mask, 0);
   evas_object_key_ungrab(win, "l", mod_mask, 0);

   evas_object_key_ungrab(win, "y", mod_mask, 0);
   evas_object_key_ungrab(win, "x", mod_mask, 0);
   evas_object_key_ungrab(win, "c", mod_mask, 0);
   evas_object_key_ungrab(win, "v", mod_mask, 0);
   evas_object_key_ungrab(win, "b", mod_mask, 0);
   evas_object_key_ungrab(win, "n", mod_mask, 0);
   evas_object_key_ungrab(win, "m", mod_mask, 0);


}
static void patch_name_entr_fun3(void *data, Evas_Object *obj, void *event_info){
   fprintf(stdout, "patch_name_entr_fun DREI\n");
   int keygrab = 0;

   keygrab = evas_object_key_grab(win, "q", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "w", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "e", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "r", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "t", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "z", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "u", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "i", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "o", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "p", 0, 0, EINA_TRUE);

   keygrab = evas_object_key_grab(win, "a", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "s", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "d", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "f", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "g", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "h", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "j", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "k", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "l", 0, 0, EINA_TRUE);

   keygrab = evas_object_key_grab(win, "y", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "x", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "c", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "v", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "b", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "n", 0, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "m", 0, 0, EINA_TRUE);

   Evas *the_evas = evas_object_evas_get(win);
   Evas_Modifier_Mask mod_mask = evas_key_modifier_mask_get(the_evas, "Shift");
   keygrab = evas_object_key_grab(win, "q", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "w", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "e", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "r", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "t", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "z", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "u", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "i", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "o", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "p", mod_mask, 0, EINA_TRUE);

   keygrab = evas_object_key_grab(win, "a", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "s", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "d", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "f", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "g", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "h", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "j", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "k", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "l", mod_mask, 0, EINA_TRUE);

   keygrab = evas_object_key_grab(win, "y", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "x", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "c", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "v", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "b", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "n", mod_mask, 0, EINA_TRUE);
   keygrab = evas_object_key_grab(win, "m", mod_mask, 0, EINA_TRUE);

}
static void gen_patch_name_button_fun(void *data, Evas_Object *obj, void *event_info){
    fprintf(stdout, "gen_patch_name_button_fun\n");

    int val = elm_check_state_get(gen_syllables_check);

    char patch_name[11];
    escwyp_gen_random_string(patch_name, val);
    fprintf(stdout, "THE PATCH NAME = %s\n", patch_name);
    //Evas_Object *the_entry = (Evas_Object *) data; //doesn't work
    elm_entry_entry_set(patch_name_entr, patch_name);

 
}

static void gen_syllables_check_fun(void *data, Evas_Object *obj, void *event_info){

    fprintf(stdout, "Yis gen_syllables_check_fun\n");
    int val = elm_check_state_get(obj);
    fprintf(stdout, "GEN_SYLLBS %i\n", val);


}

static void save_patch_button_fun(void *data, Evas_Object *obj, void *event_info){

    const char *entr_text = elm_entry_entry_get(patch_name_entr);
    fprintf(stdout, "ABC THE ENTRY TXT2 = %s\n", entr_text);
    do_save_the_patch(entr_text);

}

static void do_save_the_patch(const char *the_name){

    Eet_File *ef;
    eet_init();
    ef = eet_open("testpatch.eet", EET_FILE_MODE_READ_WRITE);

    char glob[255];
    glob[0] = 47;
    glob[1] = 0;
    strcat(glob, "PATCH_NAME/");
    switch(current_sound_function){

        case 1: { 
                    strcat(glob, "chain/");
                    break; 
                }
        case 2: { 
                    strcat(glob, "chain/");
                    break; 
                }
        case 3: { 
                    strcat(glob, "sine_robin/");
                    break; 
                }
        case 4: { 
                    strcat(glob, "sine_grass/"); 
                    break; 
                }
        case 5: { 
                    strcat(glob, "nadelper/");
                    break; 
                }
        case 6: { 
                    strcat(glob, "samplecast/");
                    break; 
                }
        case 7: { 
                    strcat(glob, "spratz/"); 
                    break; 
                }
    }
    strcat(glob, the_name);
    
    int num_matches = 0;
    char **liste = eet_list(ef, glob, &num_matches);
    fprintf(stdout, "NUM_MATCHES = %i, %s\n", num_matches, glob);
    if(num_matches == 0){
        fprintf(stdout, "HEY HIER\n");
        escwyp_patch_save(ef, the_name);
        int une = 1;
        elm_list_item_append(patch_list, the_name, NULL, NULL, patch_list_fun, &une);
        fprintf(stdout, "Guilbert\n");
        elm_list_go(patch_list);
        fprintf(stdout, "Guilbert 2\n");
        evas_object_show(patch_list);
        Elm_Object_Item *last_item = elm_list_last_item_get(patch_list);
        
        if(last_item){
            fprintf(stdout, "Guilbert 3\n");
            elm_list_item_selected_set(last_item, EINA_TRUE);
            fprintf(stdout, "Guilbert 4\n");
        }
    }else{
        fprintf(stdout, "HEY HIER 2\n");
        escwyp_patch_save(ef, the_name);
    }
        
    fprintf(stdout, "Guilbert 5\n");
    if(liste){
        free(liste);
    }    

    //ef = eet_open("testpatch.eet", EET_FILE_MODE_READ);
    eet_sync(ef);
    eet_close(ef);
    eet_shutdown();


}
