// Copyright 2014-2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version.
//
// This Library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this Library.  If not, see <http://www.gnu.org/licenses/>.

#include <math.h>
#include <stdio.h>
//#include "escwyp_globals_extern.h"
//#include "escwyp_klavier_extern.h"
#include "escwyp_samplecast.h"


void samplecastConstructor()
{

    the_params->samplecast_schieber[0] = samplecast_init_value;
    int i;
    for(i = 1; i < 10; ++i){
        the_params->samplecast_schieber[i] = 0.0;
    } 
    for(i = 0; i < 10; ++i){
        samplecast_vorfakts[i] = 0.5;
    } 

}

void samplecast_default_params(struct samplecast_params *the_params)
{

    the_params->samplecast_schieber[0] = samplecast_init_value;
    int i;
    for(i = 1; i < 10; ++i){
        the_params->samplecast_schieber[i] = 0.0;
    } 
    for(i = 0; i < 10; ++i){
        the_params->samplecast_vorfakts[i] = 0.5;
    } 

}

void print_params_samplecast(struct samplecast_params *the_params)
{

   if(the_params != NULL){

      fprintf(stdout, "-----------------\n");
      int i;
      fprintf(stdout, "samplecast_schieber ");
      for(i = 0; i < 10; ++i){
         fprintf(stdout, "[%f]", the_params->samplecast_schieber[i]);
      }
      fprintf(stdout, "\n");
      fprintf(stdout, "samplecast_vorfakts ");
      for(i = 0; i < 10; ++i){
         fprintf(stdout, "[%f]", the_params->samplecast_vorfakts[i]);
      }
      fprintf(stdout, "\n");
      for(i = 0; i < 10; ++i){
         fprintf(stdout, "[%f]", samplecast_vorfakts[i]);
      }
      fprintf(stdout, "\n");
      fprintf(stdout, "-----------------\n");
   }else{
      fprintf(stdout, "Pardon, no params set.\n");
   }
}


void samplecast_refresh_parameters()
{

        // the_params->samplecast_vorfakts enthält nur die Vorzeichen der Vorfakts
        // samplecast_vorfakts enthält dagegen immer die Werte, die in der GUI bzw. auf andere art vom User
        // angegeben wird.
        // Um den momentanen Wert des kompletten Vorfakts für eine Stimme (the_params) zu kriegen
        // müssen beide in makeSamplecast multipliziert werden.

    int i;
    // Werte nicht an die set_freq-Methode gebunden:
    //for(i = 0; i < 10; ++i){
    //    if(signbit(the_params->samplecast_vorfakts[i]) != 0){
    //        the_params->samplecast_vorfakts[i] = -1*samplecast_vorfakts[i];
    //    }else{
    //        the_params->samplecast_vorfakts[i] = samplecast_vorfakts[i];
    //    }
    //}
    //if(samplecast_mode == 0){
    //    if(signbit(the_params->samplecast_vorfakts[i]) != 0){
    //        the_params->samplecast_vorfakts[samplecast_mode_opt] = -1*samplecast_vorfakts[i];
    //    }
    //}
    // Werte an set_freq-Methode gebunden:
    if(samplecast_mode == 0){
        for(i = 0; i < 10; ++i){
            if(i != samplecast_mode_opt){
                if(signbit(the_params->samplecast_vorfakts[i]) != 0){
                    the_params->samplecast_vorfakts[i] = -1*samplecast_vorfakts[i];
                }else{
                    the_params->samplecast_vorfakts[i] = samplecast_vorfakts[i];
                }
            }
        }
    }
    
}

void samplecast_set_params(struct samplecast_params *params)
{

   the_params = params;
}

void samplecast_set_freq(const float freq)
{

    fprintf(stdout, "AHJA (freq=%f)\n", freq);
    if(samplecast_mode == 0){
        the_params->samplecast_vorfakts[samplecast_mode_opt] = freq;
    }else{
        int i;
        for(i = 0; i < 10; ++i){
            the_params->samplecast_vorfakts[i] = freq;
        }
    }
}

void samplecast_set_freq_from_klavier(const float freq, const float low_freq, const float high_freq)
{

    fprintf(stdout, "AHJA %f (freq=%f)(0=%f, 131=%f)\n", (freq-low_freq)/(high_freq-low_freq), freq, low_freq, high_freq);
    if(high_freq-low_freq > 0){
       if(!self_control){
           if(samplecast_mode == 0){
               the_params->samplecast_vorfakts[samplecast_mode_opt] = (freq-low_freq)/(high_freq-low_freq);
           }else{
               int i;
               for(i = 0; i < 10; ++i){
                   the_params->samplecast_vorfakts[i] = (freq-low_freq)/(high_freq-low_freq);
               }
           }
       }
    }


}

void samplecast_init_values()
{

    the_params->samplecast_schieber[0] = samplecast_init_value;
    int i;
    for(i = 1; i < 10; ++i){
        the_params->samplecast_schieber[i] = 0.0;
    } 
    for(i = 0; i < 10; ++i){
        the_params->samplecast_vorfakts[i] = samplecast_vorfakts[i];
    } 

}

//---------------- This function is called when key6 is pressed -------------------

void makeSamplecast(const int length, float *buff_L)
{
    int i = 0;
    while(i < length){

        float printfloat_plus = 0.0;
        float printfloat_times = 1.0;
        int j = 0;
        for(j = 0; j < 10; ++j){
            the_params->samplecast_schieber[j] = the_params->samplecast_schieber[j] + the_params->samplecast_vorfakts[j]*the_params->samplecast_schieber[(10+j-1)%10];
            if(the_params->samplecast_schieber[j] > 1.0){
                the_params->samplecast_vorfakts[j] *= -1;
                the_params->samplecast_schieber[j] = the_params->samplecast_schieber[j] + 2*the_params->samplecast_vorfakts[j]*the_params->samplecast_schieber[(10+j-1)%10];
                // das "mal 2" weil the_params->samplecast_schieber[j] schon den neuen Wert > 1.0 hat und einmal der Überschuss
                // abgezogen (siehe the_params->samplecast_vorfakts[j] *= -1) wird, und dann nochmal der eigentliche Abzug stattfindet 
            }
            if(the_params->samplecast_schieber[j] < -1.0){
                the_params->samplecast_vorfakts[j] *= -1;
                the_params->samplecast_schieber[j] = the_params->samplecast_schieber[j] + 2*the_params->samplecast_vorfakts[j]*the_params->samplecast_schieber[(10+j-1)%10];
                // das "mal 2" weil the_params->samplecast_schieber[j] schon den neuen Wert < -1.0 hat und einmal der Überschuss
                // auaddiert (siehe the_params->samplecast_vorfakts[j] *= -1) wird, und dann nochmal die eigentliche Addition stattfindet 
            }
            if(samplecast_mode == 0 && j == samplecast_mode_opt){
                buff_L[i] = (float) the_params->samplecast_schieber[j];
                ++i;
            }
            if(samplecast_mode == 1){
                printfloat_plus += the_params->samplecast_schieber[j];
            }
            if(samplecast_mode == 2){
                printfloat_times *= the_params->samplecast_schieber[j];
            }
            if(samplecast_mode == 3){
                if(i < length){
                    buff_L[i] = (float) the_params->samplecast_schieber[j];
                    ++i;
                }else{
                    break;
                }
            }
        }
        if(samplecast_mode == 1){
            buff_L[i] = (float) printfloat_plus/10;
            ++i;
        }
        if(samplecast_mode == 2){
            buff_L[i] = (float) printfloat_times*samplecast_mode_opt;
            ++i;
        }
    }
}

//-------------------------------------------------------------

// getters
float samplecast_get_vorfakts(const int index)
{

    return samplecast_vorfakts[index];

}

float samplecast_get_init_value()
{

    return samplecast_init_value;
}

int samplecast_get_mode()
{

    return samplecast_mode;

}

int samplecast_get_mode_opt()
{

    return samplecast_mode_opt;

}

// setters
void samplecast_set_vorfakts(const int index, const float fakt)
{

    samplecast_vorfakts[index] = fakt;

}

void samplecast_set_init_value(const float value)
{

    samplecast_init_value = value;

}

void samplecast_set_mode(const int mode)
{

    samplecast_mode = mode;

}

void samplecast_set_mode_opt(const int mode_opt)
{

    samplecast_mode_opt = mode_opt;

}
void samplecast_set_self_control(const int value)
{

    self_control = value;

}
int samplecast_get_self_control()
{

    return self_control;

}

