// Copyright 2014-2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version.
//
// This Library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this Library.  If not, see <http://www.gnu.org/licenses/>.

#ifndef ESCWYP_SAMPLECAST_H
#define ESCWYP_SAMPLECAST_H
#include "escwyp_samplecast_params.h"

void samplecast_default_params(struct samplecast_params *the_params);
void print_params_samplecast(struct samplecast_params *the_params);

static struct samplecast_params default_params;
static struct samplecast_params *the_params = &default_params;

static float samplecast_vorfakts[10]; 
static float samplecast_init_value = 0.3; 
static int samplecast_mode = 0; 
static int samplecast_mode_opt = 0; 

static int self_control = 0;

void samplecastConstructor();

void samplecast_refresh_parameters();
void samplecast_set_params(struct samplecast_params *params);
void samplecast_set_freq(const float freq);
void samplecast_set_freq_from_klavier(const float freq, const float low_freq, const float high_freq);
void samplecast_init_values();
void makeSamplecast(const int length, float *buff_L);

float samplecast_get_vorfakts(const int index);
float samplecast_get_init_value();
int samplecast_get_mode();
int samplecast_get_mode_opt();

void samplecast_set_vorfakts(const int index, const float fakt);
void samplecast_set_init_value(const float value);
void samplecast_set_mode(const int mode);
void samplecast_set_mode_opt(const int mode_opt);
void samplecast_set_self_control(const int value);
int samplecast_get_self_control();

#endif
