// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#include "escwyp_samplecast_gui_elm.h"
#include "escwyp_samplecast_extern.h"
#include <Elementary.h>

void samplecastPackGui(Evas_Object *box){

    elm_box_pack_end(box, samplecast_init_value_slider);
    evas_object_show(samplecast_init_value_slider);

    elm_box_pack_end(box, samplecast_register_table);
    evas_object_show(samplecast_register_table);

    elm_box_pack_end(box, samplecast_mode_radios_box);
    evas_object_show(samplecast_mode_radios_box);

    elm_box_pack_end(samplecast_mode_radios_box, samplecast_mode_radios[0]);
    evas_object_show(samplecast_mode_radios[0]);

    int i;
    for(i = 1; i < 4; ++i){
        elm_box_pack_end(samplecast_mode_radios_box, samplecast_mode_radios[i]);
        evas_object_show(samplecast_mode_radios[i]);
    }

    for(i = 0; i < 10; ++i){
        elm_table_pack(samplecast_register_table, samplecast_register_sliders[i], i, 0, 1, 1);
        evas_object_show(samplecast_register_sliders[i]);
           elm_object_disabled_set(samplecast_register_sliders[i], EINA_FALSE);
    }
    //samplecast_refresh_gui_elems();

    elm_table_pack(samplecast_register_table, samplecast_register_select_radios[0], 0, 1, 1, 1);
    for(i = 1; i < 10; ++i){
       elm_table_pack(samplecast_register_table, samplecast_register_select_radios[i], numbees[i], 1, 1, 1);
    }

    int mode = samplecast_get_mode();
    if(mode == 0){
       for(i = 0; i < 10; ++i){
          evas_object_show(samplecast_register_select_radios[i]);
       }
    }else{
       for(i = 0; i < 10; ++i){
          evas_object_hide(samplecast_register_select_radios[i]);
       }
    }

    elm_box_pack_end(box, samplecast_magnify_slider);
    if(mode == 2){
        evas_object_show(samplecast_magnify_slider); 
    }else{
        evas_object_hide(samplecast_magnify_slider); 
    }
}

void samplecastUnpackGui(Evas_Object *box){

    elm_box_unpack(box, samplecast_init_value_slider);
    evas_object_hide(samplecast_init_value_slider);

    elm_box_unpack(box, samplecast_register_table);
    evas_object_hide(samplecast_register_table);

    elm_box_unpack(box, samplecast_mode_radios_box);
    evas_object_hide(samplecast_mode_radios_box);

    elm_box_unpack(samplecast_mode_radios_box, samplecast_mode_radios[0]);
    evas_object_hide(samplecast_mode_radios[0]);

    int i;
    for(i = 1; i < 4; ++i){
        elm_box_unpack(samplecast_mode_radios_box, samplecast_mode_radios[i]);
        evas_object_hide(samplecast_mode_radios[i]);
    }

    for(i = 0; i < 10; ++i){
        elm_table_pack(samplecast_register_table, samplecast_register_sliders[i], i, 0, 1, 1);
        evas_object_hide(samplecast_register_sliders[i]);
    }

    elm_table_pack(samplecast_register_table, samplecast_register_select_radios[0], 0, 1, 1, 1);
    evas_object_hide(samplecast_register_select_radios[0]);

    for(i = 1; i < 10; ++i){
        elm_table_pack(samplecast_register_table, samplecast_register_select_radios[i], numbees[i], 1, 1, 1);
        evas_object_hide(samplecast_register_select_radios[i]);
    }

    elm_box_unpack(box, samplecast_magnify_slider);
    evas_object_hide(samplecast_magnify_slider);

}

void samplecastInitGuiElm(int hidden){

    // the box containing all of the following
    samplecast_base_box = elm_box_add(win);
    //evas_object_size_hint_weight_set(box2, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
    //evas_object_size_hint_align_set(box2, EVAS_HINT_FILL, EVAS_HINT_FILL);
    //elm_box_align_set(box2, 0.5, 0.0);
    //elm_box_horizontal_set(distrib_base_box, EINA_TRUE);
    if(hidden == 0){
        //elm_box_pack_end(change_box, samplecast_base_box);
        //evas_object_show(samplecast_base_box);
        //evas_object_hide(samplecast_base_box);
    }

    //the init value slider
    samplecast_init_value_slider = elm_slider_add(win);
    evas_object_size_hint_align_set(samplecast_init_value_slider, EVAS_HINT_FILL, 0.5);
    evas_object_size_hint_weight_set(samplecast_init_value_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
    elm_slider_unit_format_set(samplecast_init_value_slider, "%1.2f INI");
    elm_slider_indicator_show_set(samplecast_init_value_slider, EINA_FALSE);
    elm_slider_min_max_set(samplecast_init_value_slider, 0.0, 1.0);
    elm_slider_value_set(samplecast_init_value_slider, samplecast_get_init_value());
    elm_slider_horizontal_set(samplecast_init_value_slider, EINA_TRUE);
    elm_slider_span_size_set(samplecast_init_value_slider, 200);
    evas_object_smart_callback_add(samplecast_init_value_slider, "delay,changed", samplecast_init_value_slider_fun, NULL);    

    //the table containing the register-sliders
    samplecast_register_table = elm_table_add(win);
    elm_table_padding_set(samplecast_register_table, 6, 2);

    samplecast_mode_radios_box = elm_box_add(win);
    //evas_object_size_hint_weight_set(box2, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
    //evas_object_size_hint_align_set(box2, EVAS_HINT_FILL, EVAS_HINT_FILL);
    //elm_box_align_set(box2, 0.5, 0.0);
    elm_box_horizontal_set(samplecast_mode_radios_box, EINA_TRUE);

    // the mode radios
    int i;
    samplecast_mode_radios[0] = elm_radio_add(win);
    elm_radio_state_value_set(samplecast_mode_radios[0], 0);
    evas_object_smart_callback_add(samplecast_mode_radios[0], "changed", samplecast_mode_radios_fun, NULL);
    elm_object_part_text_set(samplecast_mode_radios[0], NULL, namees[0]);

    for(i = 1; i < 4; ++i){
        numbees[i] = i;
        samplecast_mode_radios[i] = elm_radio_add(win);
        elm_radio_state_value_set(samplecast_mode_radios[i], numbees[i]);
        elm_radio_group_add(samplecast_mode_radios[i], samplecast_mode_radios[0]);
        elm_object_part_text_set(samplecast_mode_radios[i], NULL, namees[i]);
        evas_object_smart_callback_add(samplecast_mode_radios[i], "changed", samplecast_mode_radios_fun, NULL);
    }

    samplecast_widgets = elm_box_children_get(samplecast_mode_radios_box);
    // the register sliders
    for(i = 0; i < 10; ++i){
        numbees[i] = i;
        samplecast_register_sliders[i] = elm_slider_add(win);
        evas_object_size_hint_align_set(samplecast_register_sliders[i], EVAS_HINT_FILL, 0.5);
        evas_object_size_hint_weight_set(samplecast_register_sliders[i], EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
        elm_slider_unit_format_set(samplecast_register_sliders[i], "%1.2f");
        elm_slider_indicator_show_set(samplecast_register_sliders[i], EINA_FALSE);
        elm_slider_min_max_set(samplecast_register_sliders[i], 0.0, 1.0);
        elm_slider_value_set(samplecast_register_sliders[i], samplecast_get_vorfakts(i));
        elm_slider_horizontal_set(samplecast_register_sliders[i], EINA_FALSE);
        elm_slider_span_size_set(samplecast_register_sliders[i], 80);
        evas_object_smart_callback_add(samplecast_register_sliders[i], "delay,changed", samplecast_register_sliders_fun, &numbees[i]);    
        //elm_box_pack_end(samplecast_reg_box, samplecast_register_sliders[i]);
    }

    // the radio selects
    samplecast_register_select_radios[0] = elm_radio_add(win);
    elm_radio_state_value_set(samplecast_register_select_radios[0], 0);
    evas_object_smart_callback_add(samplecast_register_select_radios[0], "changed", samplecast_register_select_radios_fun, NULL);

    for(i = 1; i < 10; ++i){
        samplecast_register_select_radios[i] = elm_radio_add(win);
        elm_radio_state_value_set(samplecast_register_select_radios[i], numbees[i]);
        elm_radio_group_add(samplecast_register_select_radios[i], samplecast_register_select_radios[0]);
        //elm_object_part_text_set(samplecast_register_select_radios[i], NULL, "N");
        evas_object_smart_callback_add(samplecast_register_select_radios[i], "changed", samplecast_register_select_radios_fun, NULL);
    }

    //the magnify slider
    samplecast_magnify_slider = elm_slider_add(win);
    evas_object_size_hint_align_set(samplecast_magnify_slider, EVAS_HINT_FILL, 0.5);
    evas_object_size_hint_weight_set(samplecast_magnify_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
    elm_slider_unit_format_set(samplecast_magnify_slider, "%1.0f MAG");
    elm_slider_indicator_show_set(samplecast_magnify_slider, EINA_FALSE);
    elm_slider_min_max_set(samplecast_magnify_slider, 1.0, 1000.0);
    elm_slider_value_set(samplecast_magnify_slider, magnify);
    elm_slider_horizontal_set(samplecast_magnify_slider, EINA_TRUE);
    elm_slider_span_size_set(samplecast_magnify_slider, 200);
    evas_object_smart_callback_add(samplecast_magnify_slider, "delay,changed", samplecast_magnify_slider_fun, NULL);    

}

static void samplecast_init_value_slider_fun(void *data, Evas_Object *obj, void *event_info){

    fprintf(stdout, "Yis samplecast_init_value_slider_fun\n");
    float val = (float) elm_slider_value_get(obj);
    samplecast_set_init_value(val);
    fprintf(stdout, "Samplecast init value %f\n", val);

}

static void samplecast_register_sliders_fun(void *data, Evas_Object *obj, void *event_info){

    fprintf(stdout, "Yis samplecast_register_sliders_fun\n");
    float val = (float) elm_slider_value_get(obj);
    int *tmp_data = (int *) data;
    samplecast_set_vorfakts(*tmp_data, val);
    fprintf(stdout, "Samplecast register %i value =  %f\n", *tmp_data, val);

}

static void samplecast_register_select_radios_fun(void *data, Evas_Object *obj, void *event_info){

    fprintf(stdout, "Yis samplecast_register_select_radios_fun\n");
    register_select = elm_radio_value_get(obj);
    if(samplecast_get_mode() == 0){
        samplecast_set_mode_opt(register_select);
    }

    samplecast_refresh_gui_elems();
    fprintf(stdout, "Samplecast register select = %i/%i\n", register_select, samplecast_get_mode_opt());
}

static void samplecast_mode_radios_fun(void *data, Evas_Object *obj, void *event_info){

    fprintf(stdout, "Yis samplecast_mode_radios_fun\n");
    mode = elm_radio_value_get(obj);
    samplecast_set_mode(mode);
    int i;
    if(mode == 0){
        for(i = 0; i < 10; ++i){
            evas_object_show(samplecast_register_select_radios[i]);
        }
        samplecast_set_mode_opt(register_select);
    }else{
        for(i = 0; i < 10; ++i){
            evas_object_hide(samplecast_register_select_radios[i]);
        }
    }
    if(mode == 2){
        evas_object_show(samplecast_magnify_slider); 
        samplecast_set_mode_opt(magnify);
    }else{
        evas_object_hide(samplecast_magnify_slider); 
    }
    
    samplecast_refresh_gui_elems();

    fprintf(stdout, "Samplecast mode = %i\n", mode);

}

static void samplecast_magnify_slider_fun(void *data, Evas_Object *obj, void *event_info){

    fprintf(stdout, "Yis samplecast_magnify_slider_fun\n");
    magnify = (int) round(elm_slider_value_get(obj));
    if(samplecast_get_mode() == 2){
        samplecast_set_mode_opt(magnify);
    }
    fprintf(stdout, "Samplecast magnify = %i\n", magnify);

}

void samplecast_register_sliders_set(const int index, float value){

    double d = (double) value; 
    fprintf(stdout, "Samplecast reg %i = %f %f\n", index, value, d);
    elm_slider_value_set(samplecast_register_sliders[index], d);

}

void samplecast_mode_radios_set(int value){

    elm_radio_value_set(samplecast_mode_radios[0], value);
    if(value == 0){
        int i;
        for(i = 0; i < 10; ++i){
            evas_object_show(samplecast_register_select_radios[i]);
        }
        fprintf(stdout, "OOO %i\n", value);
    }else{
        int i;
        for(i = 0; i < 10; ++i){
            evas_object_hide(samplecast_register_select_radios[i]);
        }
        fprintf(stdout, "OOOa %i\n", value);
    }
    if(value == 2){
        evas_object_show(samplecast_magnify_slider); 
        fprintf(stdout, "OOOb %i\n", value);
    }else{
        evas_object_hide(samplecast_magnify_slider); 
        fprintf(stdout, "OOOc %i\n", value);
    }

}

void samplecast_register_select_radios_set(int value){

    elm_radio_value_set(samplecast_register_select_radios[0], value);

}

void samplecast_magnify_slider_set(float value){

    elm_slider_value_set(samplecast_magnify_slider, (double) value);

}

void samplecast_init_value_slider_set(float value){

    elm_slider_value_set(samplecast_init_value_slider, (double) value);

}
void samplecast_gui_set_self_control(const int value)
{
    samplecast_set_self_control(value);
    samplecast_refresh_gui_elems();
//    if(samplecast_get_self_control()){
//        int i;
//        for(i = 0; i < 10; ++i){
//           elm_object_disabled_set(samplecast_register_sliders[i], EINA_FALSE);
//        }
//    }else{
//       if(samplecast_get_mode() == 0){
//          elm_object_disabled_set(samplecast_register_sliders[samplecast_get_mode_opt()], EINA_TRUE);
//       }else{
//           int i;
//           for(i = 0; i < 10; ++i){
//              elm_object_disabled_set(samplecast_register_sliders[i], EINA_TRUE);
//           }
//       }
//       
//    }

}

void samplecast_refresh_gui_elems()
{

    int i;
    if(samplecast_get_self_control()){
        for(i = 0; i < 10; ++i){
           elm_object_disabled_set(samplecast_register_sliders[i], EINA_FALSE);
        }
    }else{
       if(samplecast_get_mode() == 0){
           for(i = 0; i < 10; ++i){
              elm_object_disabled_set(samplecast_register_sliders[i], EINA_FALSE);
           }
           elm_object_disabled_set(samplecast_register_sliders[samplecast_get_mode_opt()], EINA_TRUE);
       }else{
           for(i = 0; i < 10; ++i){
              elm_object_disabled_set(samplecast_register_sliders[i], EINA_TRUE);
           }
       }
    }


}
