// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#ifndef ESCWYP_SINE_GRASS_GUI_ELM_H
#define ESCWYP_SINE_GRASS_GUI_ELM_H
#include "escwyp_globals_extern.h"


static Evas_Object *sine_grass_freq_slider;
static Evas_Object *grass_mowed_check;
static Evas_Object *grass_hill_fraction_slider;
static Evas_Object *lawn_length_variation_frac_slider;
static Evas_Object *box_check; 
static Evas_Object *sg_check_0; 
static Evas_Object *sg_check_1; 
static Evas_Object *sg_check_2; 
static Evas_Object *sg_check_3; 
static Evas_Object *sg_check_4; 
static Evas_Object *sg_check_5; 
static Evas_Object *sg_check_6; 
static Evas_Object *sg_check_7; 
static Evas_Object *box_radio; 
static Evas_Object *sg_radio_0; 
static Evas_Object *sg_radio_1; 
static Evas_Object *sg_radio_2; 
static Evas_Object *sg_radio_3; 
static Evas_Object *sg_check_objs[8];

static int sg_check_0_state = 0;
static int sg_check_0_indicator = 0;
static int sg_check_1_state = 0;
static int sg_check_1_indicator = 1;
static int sg_check_2_state = 0;
static int sg_check_2_indicator = 2;
static int sg_check_3_state = 0;
static int sg_check_3_indicator = 3;
static int sg_check_4_state = 0;
static int sg_check_4_indicator = 4;
static int sg_check_5_state = 0;
static int sg_check_5_indicator = 5;
static int sg_check_6_state = 0;
static int sg_check_6_indicator = 6;
static int sg_check_7_state = 0;
static int sg_check_7_indicator = 7;
static int sg_check_combined_state = 0;
static int sg_radio_val = 0;

static void sine_grass_freq_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void grass_mowed_check_fun(void *data, Evas_Object *obj, void *event_info);
static void grass_hill_fraction_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void lawn_length_variation_frac_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void sg_check_0_fun(void *data, Evas_Object *obj, void *event_info);
static void sg_check_1_fun(void *data, Evas_Object *obj, void *event_info);
static void sg_check_2_fun(void *data, Evas_Object *obj, void *event_info);
static void sg_check_3_fun(void *data, Evas_Object *obj, void *event_info);
static void sg_check_4_fun(void *data, Evas_Object *obj, void *event_info);
static void sg_check_5_fun(void *data, Evas_Object *obj, void *event_info);
static void sg_check_6_fun(void *data, Evas_Object *obj, void *event_info);
static void sg_check_7_fun(void *data, Evas_Object *obj, void *event_info);
static void sg_radio_fun(void *data, Evas_Object *obj, void *event_info);

//Evas_Object *sine_grass_base_box; 

void sineGrassInitGui(const int hidden);
void sineGrassPackGui(Evas_Object *box);
void sineGrassUnpackGui(Evas_Object *box);

void sine_grass_freq_slider_set(const float value);
void sine_grass_grass_mowed_check_set(const int value);
void sine_grass_grass_hill_fraction_slider_set(const float value);
void sine_grass_lawn_length_variation_frac_slider_set(const float value);
void sine_grass_gui_set_self_control(const int value);

#endif
