// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#ifndef ESCWYP_SINE_ROBIN_GUI_ELM_H
#define ESCWYP_SINE_ROBIN_GUI_ELM_H

#include <Evas.h>

static unsigned int *pixels;



// width and height of the graph of the distribution displayed
static const int sine_robin_distrib_image_width = 100;
static const int sine_robin_distrib_image_height = 50;

static int sine_robin_plot_step_width = 20;

////////
static Evas_Object *sine_robin_center_slider; 
static Evas_Object *sine_robin_height_slider;
static Evas_Object *box_radio; 
static Evas_Object *sine_robin_radio_0; 
static Evas_Object *sine_robin_radio_1; 
static Evas_Object *sine_robin_radio_2; 
static Evas_Object *sine_robin_radio_3; 
static Evas *canv;
static Evas_Object *im_sine_robin_default;
static Evas_Object *sine_robin_image_table; 
static Evas_Object *sine_robin_image_box_left; 
static Evas_Object *sine_robin_image_box_bottom;
static Evas_Object *exper_box; 
static Evas_Object *sine_robin_height_fine_frac_slider;
static Evas_Object *sine_robin_max_label; 
static Evas_Object *sine_robin_min_label; 
static Evas_Object *sine_robin_x_min_label; 
static Evas_Object *sine_robin_x_max_label; 
static Evas_Object *sine_robin_center_label; 
static Evas_Object *sine_robin_max_shown_label; 
static Evas_Object *sine_robin_min_shown_label; 
static Evas_Object *sine_robin_left_shown_label ; 
static Evas_Object *sine_robin_right_shown_label ; 
static Evas_Object *scr_sine_robin;
static Evas_Object *sine_robin_high_slider; 
static Evas_Object *sine_robin_low_slider;
static Evas_Object *sine_robin_plot_step_size_slider;
//static Ecore_Evas *ee;

static void sine_robin_center_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void sine_robin_height_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void sine_robin_height_fine_frac_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void sine_robin_low_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void sine_robin_high_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void sine_robin_radio_fun(void *data, Evas_Object *obj, void *event_info);
static void sine_robin_plot_step_size_slider_fun(void *data, Evas_Object *obj, void *event_info);

void sineRobinInitGui();
void sineRobinPackGui(Evas_Object *box);
void sineRobinUnpackGui(Evas_Object *box);
void makeDistribImage();

void sine_robin_center_slider_set(const float value);
void sine_robin_height_slider_set(const float value);
void sine_robin_height_fine_frac_slider_set(const float value);
void sine_robin_low_slider_set(const float value);
void sine_robin_high_slider_set(const float value);
void sine_robin_radio_0_set(const int value);
void sine_robin_plot_step_size_slider_set(const float value);
void sine_robin_gui_set_self_control(const int value);

#endif
