// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#include <Elementary.h>
#include "escwyp_spratz_gui_elm.h"
#include "escwyp_spratz_extern.h"

void spratzPackGui(Evas_Object *box){

    elm_box_pack_end(box, spratz_y_fact_slider);
    evas_object_show(spratz_y_fact_slider);

    elm_box_pack_end(box, spratz_x_fact_slider);
    evas_object_show(spratz_x_fact_slider);

    elm_box_pack_end(box, spratz_depth_slider);
    evas_object_show(spratz_depth_slider);

    elm_box_pack_end(box, spratz_samplerate_slider);
    evas_object_show(spratz_samplerate_slider);
    int w, h;
    //evas_object_geometry_get(frame1, 0, 0, &w, &h);
    //fprintf(stdout, "pack FRAME1 w=%i, h=%i\n", w, h);

}

void spratzUnpackGui(Evas_Object *box){

    //int w, h;
    //evas_object_geometry_get(frame1, 0, 0, &w, &h);
    //fprintf(stdout, "unpack FRAME1 w=%i, h=%i\n", w, h);
    elm_box_unpack(box, spratz_y_fact_slider);
    evas_object_hide(spratz_y_fact_slider);

    elm_box_unpack(box, spratz_x_fact_slider);
    evas_object_hide(spratz_x_fact_slider);

    elm_box_unpack(box, spratz_depth_slider);
    evas_object_hide(spratz_depth_slider);

    elm_box_unpack(box, spratz_samplerate_slider);
    evas_object_hide(spratz_samplerate_slider);
}

void spratzInitGuiElm(int hidden){


    //the y_fact slider
    spratz_y_fact_slider = elm_slider_add(win);
    evas_object_size_hint_align_set(spratz_y_fact_slider, EVAS_HINT_FILL, 0.5);
    evas_object_size_hint_weight_set(spratz_y_fact_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
    elm_slider_unit_format_set(spratz_y_fact_slider, "%1.2f y_fact");
    elm_slider_indicator_show_set(spratz_y_fact_slider, EINA_FALSE);
    elm_slider_min_max_set(spratz_y_fact_slider, 0.01, 5.0);
    elm_slider_value_set(spratz_y_fact_slider, spratz_get_y_fact());
    elm_slider_horizontal_set(spratz_y_fact_slider, EINA_TRUE);
    elm_slider_span_size_set(spratz_y_fact_slider, 200);
    evas_object_smart_callback_add(spratz_y_fact_slider, "delay,changed", spratz_y_fact_slider_fun, NULL);    

    //the x_fact slider
    spratz_x_fact_slider = elm_slider_add(win);
    evas_object_size_hint_align_set(spratz_x_fact_slider, EVAS_HINT_FILL, 0.5);
    evas_object_size_hint_weight_set(spratz_x_fact_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
    elm_slider_unit_format_set(spratz_x_fact_slider, "%1.2f x_fact");
    elm_slider_indicator_show_set(spratz_x_fact_slider, EINA_FALSE);
    elm_slider_min_max_set(spratz_x_fact_slider, 0.01, 5.0);
    elm_slider_value_set(spratz_x_fact_slider, spratz_get_x_fact());
    elm_slider_horizontal_set(spratz_x_fact_slider, EINA_TRUE);
    elm_slider_span_size_set(spratz_x_fact_slider, 200);
    evas_object_smart_callback_add(spratz_x_fact_slider, "delay,changed", spratz_x_fact_slider_fun, NULL);    

    //the depth slider
    spratz_depth_slider = elm_slider_add(win);
    evas_object_size_hint_align_set(spratz_depth_slider, EVAS_HINT_FILL, 0.5);
    evas_object_size_hint_weight_set(spratz_depth_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
    elm_slider_unit_format_set(spratz_depth_slider, "%1.0f depth");
    elm_slider_indicator_show_set(spratz_depth_slider, EINA_FALSE);
    elm_slider_min_max_set(spratz_depth_slider, 0.01, 16.0);
    elm_slider_value_set(spratz_depth_slider, spratz_get_depth());
    elm_slider_horizontal_set(spratz_depth_slider, EINA_TRUE);
    elm_slider_span_size_set(spratz_depth_slider, 200);
    evas_object_smart_callback_add(spratz_depth_slider, "delay,changed", spratz_depth_slider_fun, NULL);    

    //the samplerate slider
    spratz_samplerate_slider = elm_slider_add(win);
    evas_object_size_hint_align_set(spratz_samplerate_slider, EVAS_HINT_FILL, 0.5);
    evas_object_size_hint_weight_set(spratz_samplerate_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
    elm_slider_unit_format_set(spratz_samplerate_slider, "%1.2f samplerate");
    elm_slider_indicator_show_set(spratz_samplerate_slider, EINA_FALSE);
    elm_slider_min_max_set(spratz_samplerate_slider, 7.0, 16000.0);
    elm_slider_value_set(spratz_samplerate_slider, spratz_get_samplerate());
    elm_slider_horizontal_set(spratz_samplerate_slider, EINA_TRUE);
    elm_slider_span_size_set(spratz_samplerate_slider, 200);
    evas_object_smart_callback_add(spratz_samplerate_slider, "delay,changed", spratz_samplerate_slider_fun, NULL);    
    if(spratz_get_self_control()){
   	elm_object_disabled_set(spratz_samplerate_slider, EINA_FALSE);
    }else{
   	elm_object_disabled_set(spratz_samplerate_slider, EINA_TRUE);
    }
    //regel_timer = ecore_timer_add(0.1, regel_func, NULL);
}

Eina_Bool regel_func(void *data) {

    //spratz_set_x_fact(0.9*0.5*(sinf(regelphase*2*M_PI)+1));
    //spratz_set_y_fact(0.9*0.5*(sinf(regelphase*2*M_PI)+1));
    //spratz_set_depth(0.8*0.5*(sinf(regelphase*2*M_PI)+1));
    //regelphase += 0.01;
    //if(regelphase >= 1.0){
    //    regelphase = 0.0;
    //}
    return ECORE_CALLBACK_RENEW;
}

static void spratz_y_fact_slider_fun(void *data, Evas_Object *obj, void *event_info){

    fprintf(stdout, "Yis spratz_y_fact_slider_fun\n");
    float val = (float) elm_slider_value_get(obj);
    spratz_set_y_fact(val);
    fprintf(stdout, "Samplecast y_fact %f\n", val);

}

static void spratz_x_fact_slider_fun(void *data, Evas_Object *obj, void *event_info){

    fprintf(stdout, "Yis spratz_x_fact_slider_fun\n");
    float val = (float) elm_slider_value_get(obj);
    spratz_set_x_fact(val);
    fprintf(stdout, "Samplecast x_fact %f\n", val);

}

static void spratz_depth_slider_fun(void *data, Evas_Object *obj, void *event_info){

    fprintf(stdout, "Yis spratz_depth_slider_fun\n");
    int val = (int) round(elm_slider_value_get(obj));
    spratz_set_depth(val);
    fprintf(stdout, "Samplecast depth %i\n", val);

}

static void spratz_samplerate_slider_fun(void *data, Evas_Object *obj, void *event_info){

    fprintf(stdout, "Yis spratz_samplerate_slider_fun\n");
    float val = (float) elm_slider_value_get(obj);
    spratz_set_samplerate(val);
    fprintf(stdout, "Samplecast samplerate %f\n", val);

}

void spratz_y_fact_slider_set(float value){

    elm_slider_value_set(spratz_y_fact_slider, (double) value);

}
void spratz_x_fact_slider_set(float value){

    elm_slider_value_set(spratz_x_fact_slider, (double) value);

}
void spratz_depth_slider_set(float value){

    elm_slider_value_set(spratz_depth_slider, (double) value);

}
void spratz_samplerate_slider_set(float value){

    elm_slider_value_set(spratz_samplerate_slider, (double) value);

}
void spratz_gui_set_self_control(const int value)
{
    spratz_set_self_control(value);
    if(spratz_get_self_control()){
   	elm_object_disabled_set(spratz_samplerate_slider, EINA_FALSE);
    }else{
   	elm_object_disabled_set(spratz_samplerate_slider, EINA_TRUE);
    }
}
