// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#ifndef ESCWYP_SPRATZ_GUI_ELM_H
#define ESCWYP_SPRATZ_GUI_ELM_H
#include <Evas.h>
#include <Ecore.h>
#include "escwyp_globals_extern.h"

Evas_Object *spratz_base_box;
static Evas_Object *spratz_y_fact_slider;
static Evas_Object *spratz_x_fact_slider;
static Evas_Object *spratz_depth_slider;
static Evas_Object *spratz_samplerate_slider;
static Ecore_Timer *regel_timer;
static Eina_Bool regel_func(void *data);
static float regelphase = 0.0;
 

void spratzInitGuiElm(int hidden);
static void spratz_y_fact_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void spratz_x_fact_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void spratz_depth_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void spratz_samplerate_slider_fun(void *data, Evas_Object *obj, void *event_info);

void spratzPackGui(Evas_Object *box);
void spratzUnpackGui(Evas_Object *box);

void spratz_y_fact_slider_set(float value);
void spratz_x_fact_slider_set(float value);
void spratz_depth_slider_set(float value);
void spratz_samplerate_slider_set(float value);
void spratz_gui_set_self_control(const int value);
#endif
