// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#include "escwyp_spratz_patch_eet.h"
#include "escwyp_spratz_extern.h"
#include "escwyp_spratz_gui_elm_extern.h"
#include "escwyp_patch_select_extern.h"
#include <string.h>

void spratz_load_patch(const char *patch_name){

    fprintf(stdout, "III spratz_load_patch\n");

    void *param_p = NULL;
    void *param_pp = NULL;
    char the_base_key[255];
    char the_key[255];
    the_base_key[0] = 47;
    the_base_key[1] = 0;
    strcat(the_base_key, "spratz/"); 
    strcat(the_base_key, patch_name);

    // SPRATZ X FACT----------------------
    strcpy(the_key, the_base_key);
    strcat(the_key, "/spratz_x_fact");

    param_pp = escwyp_patch_load_param(param_p, the_key);
    if(param_pp){
       float *x_fact = (float *) param_pp;
       spratz_set_x_fact(*x_fact);
       spratz_x_fact_slider_set(*x_fact);
       fprintf(stdout, "%s %f\n", the_key, *x_fact);
       free(param_pp);
    }else{
       fprintf(stdout, "%s not there. Ohh.\n", the_key);
    }
    //--------------------------------

    // SPRATZ Y FACT----------------------
    strcpy(the_key, the_base_key);
    strcat(the_key, "/spratz_y_fact");

    if(param_pp){
       param_pp = escwyp_patch_load_param(param_p, the_key);
       float *y_fact = (float *) param_pp;
       
       spratz_set_y_fact(*y_fact);
       spratz_y_fact_slider_set(*y_fact);
       fprintf(stdout, "%s %f\n", the_key, *y_fact);
       free(param_pp);
    }else{
       fprintf(stdout, "%s not there. Ohh.\n", the_key);
    }
    //--------------------------------

    // SPRATZ DEPTH----------------------
    strcpy(the_key, the_base_key);
    strcat(the_key, "/spratz_depth");

    param_pp = escwyp_patch_load_param(param_p, the_key);
    if(param_pp){
       int *depth = (int *) param_pp;
       spratz_set_depth(*depth);
       spratz_depth_slider_set(*depth);
       fprintf(stdout, "%s %i\n", the_key, *depth);
       free(param_pp);
    }else{
       fprintf(stdout, "%s not there. Ohh.\n", the_key);
    }
    //--------------------------------

    // SPRATZ SAMPLERATE----------------------
    strcpy(the_key, the_base_key);
    strcat(the_key, "/spratz_samplerate");

    param_pp = escwyp_patch_load_param(param_p, the_key);
    if(param_pp){
       float *samplerate = (float *) param_pp;
       spratz_set_samplerate(*samplerate);
       spratz_samplerate_slider_set(*samplerate);
       fprintf(stdout, "%s %f\n", the_key, *samplerate);
       free(param_pp);
    }else{
       fprintf(stdout, "%s not there. Ohh.\n", the_key);
    }
    //--------------------------------

    // SPARTZ
}

void spratz_save_patch(const char *patch_name){

    fprintf(stdout, "spratz_save_patch\n");
    float x_fact = 1.0;
    float y_fact = 2.0;
    int depth = 0.3; 
    float samplerate = 64.0; 

    char id_string[255];
    strcpy(id_string, "/PATCH_NAME/spratz/");
    strcat(id_string, patch_name);
    escwyp_patch_save_param(patch_name, (1+strlen(patch_name))*sizeof(char), id_string);
    fprintf(stdout, "%s = %s\n", id_string, patch_name);

    char the_base_key[255];
    char the_key[255];
    the_base_key[0] = 47;
    the_base_key[1] = 0;
    strcat(the_base_key, "spratz/"); 
    strcat(the_base_key, patch_name);

    x_fact = spratz_get_x_fact();
    strcpy(the_key, the_base_key);
    strcat(the_key, "/spratz_x_fact");
    escwyp_patch_save_param(&x_fact, sizeof(float), the_key);
    fprintf(stdout, "%s %f\n", the_key, x_fact);

    y_fact = spratz_get_y_fact();
    strcpy(the_key, the_base_key);
    strcat(the_key, "/spratz_y_fact");
    escwyp_patch_save_param(&y_fact, sizeof(float), the_key);
    fprintf(stdout, "%s %f\n", the_key, y_fact);

    depth = spratz_get_depth();
    strcpy(the_key, the_base_key);
    strcat(the_key, "/spratz_depth");
    escwyp_patch_save_param(&depth, sizeof(int), the_key);
    fprintf(stdout, "%s %i\n", the_key, depth);

    samplerate = spratz_get_samplerate();
    strcpy(the_key, the_base_key);
    strcat(the_key, "/spratz_samplerate");
    escwyp_patch_save_param(&samplerate, sizeof(float), the_key);
    fprintf(stdout, "%s %f\n", the_key, samplerate);

}
