#include "escwyp_terminal.h"
#include "escwyp_main.h"
#include "escwyp_misch_extern.h"
#include "escwyp_chain_extern.h"
#include "escwyp_sine_robin_extern.h"
#include "escwyp_sine_grass_extern.h"
#include "escwyp_spratz_extern.h"
#include "escwyp_samplecast_extern.h"
#include "escwyp_nadelper_extern.h"
#include "escwyp_out_txt_extern.h"
#include <math.h>
#include <stdio.h>
#include <string.h>

static int stripnl(char *val, int size)
{

   int tina = -1;
   int lauf = 0;
   for(lauf = 0; lauf < size; lauf++){

      if(val[lauf] == 10){
         val[lauf] = 0;
         tina = lauf;
         break;
      }else{
         //fprintf(stdout, "%i: %c\n", lauf, val[lauf]);
      }
   }
   val[size - 1] = 0;
   return tina;
}

static void cleanput()
{

   fprintf(stdout, "Dirty\n");
   char inpie[25];
   char *reti = NULL;
   while(1){
      reti = fgets(inpie, 26, stdin);
      if(reti == NULL){
         break;
      }else{
         fprintf(stdout, "A: %x\n", reti);
         if(stripnl(inpie, 25) >= 0){
            break;
         }
      }
   }
   fprintf(stdout, "Cleaned\n");
}

static int terminal_readin_int(char *val, const int size, int *iv)
{

   char *reti = NULL;
   reti = fgets(val, size+1, stdin);
   if(reti){
      int nl_found = stripnl(val, size);
      if(nl_found == 0){
         return -2;
      }
      if(nl_found == -1){
         cleanput();
      }
      int scane = sscanf(val, "%i", iv);
      return 0;
   }
   return -1;
}

static int terminal_readin_float(char *val, const int size, float *fv)
{

   char *reti = NULL;
   reti = fgets(val, size+1, stdin);
   if(reti){
      int nl_found = stripnl(val, size);
      if(nl_found == 0){
         return -2;
      }
      if(nl_found == -1){
         cleanput();
      }
      int scane = sscanf(val, "%f", fv);
      return 0;
   }
   return -1;
}

static int evaluate_str(const char * const val, int size)
{

   int succ = 0;
   char first_c = val[0];
   if(first_c >= 0x30 && first_c <= 0x39){
      fprintf(stdout, "Ne Zahl %c\n", first_c);
      int zahl = 0;
      int scane = sscanf(val, "%i", &zahl);
      fprintf(stdout, "%i [%i]\n", zahl, scane);
      if(note_is_set(zahl) == 0){
         note_off(zahl);
      }else{
         note_on(zahl);
      }
   }
   if(first_c >= 0x41 && first_c <= 0x5a){
      fprintf(stdout, "N Gross %c\n", first_c);
   }
   if(first_c >= 0x61 && first_c <= 0x7a){
      fprintf(stdout, "N Klein %c\n", first_c);
         if(strcmp(val, "end") == 0){
            fprintf(stdout, "The END\n");
            succ = 2;
         }
         if(!succ && strcmp(val, "chai") == 0){
            fprintf(stdout, "%s - Switch to Chain\n", val);
            escwyp_switch_method(0);
            succ = 1;
         }
         if(!succ && strcmp(val, "robi") == 0){
            fprintf(stdout, "%s - Switch to SineRobin\n", val);
            escwyp_switch_method(1);
            succ = 1;
         }
         if(!succ && strcmp(val, "gras") == 0){
            fprintf(stdout, "%s - Switch to SineGrass\n", val);
            escwyp_switch_method(2);
            succ = 1;
         }
         if(!succ && strcmp(val, "grmo") == 0){
            fprintf(stdout, "%s - Move the Grass Parameter SineGrass\n", val);
            char mo[5];
            fprintf(stdout, "[0|1]>");
            int iv = 0;
            int tr = terminal_readin_int(mo, 5, &iv);
            if(tr == 0){
               fprintf(stdout, "%i\n", iv);
               sine_grass_set_grass_mowed(iv);
               inpie_again = 1;
            }
            if(tr == -2){
               inpie_again = 0;
            }
            succ = 1;
         }
         if(!succ && strcmp(val, "grhf") == 0){
            fprintf(stdout, "%s - Sine Grass Hill Fraction Parameter\n", val);
            char mo[5];
            fprintf(stdout, "[0.0 - 1.0]>");
            float fv = 0.0;
            int tr = terminal_readin_float(mo, 5, &fv);
            if(tr == 0){
               fprintf(stdout, "%f\n", fv);
               sine_grass_set_grass_hill_fraction(fv);
               inpie_again = 1;
            }
            if(tr == -2){
               inpie_again = 0;
            }
            succ = 1;
         }
         if(!succ && strcmp(val, "grll") == 0){
            fprintf(stdout, "%s - Sine Grass Lawn Length Variation Frac Parameter\n", val);
            char mo[5];
            fprintf(stdout, "[0.0 - 1.0]>");
            float fv = 0.0;
            int tr = terminal_readin_float(mo, 5, &fv);
            if(tr == 0){
               fprintf(stdout, "%f\n", fv);
               sine_grass_set_lawn_length_variation_frac(fv);
               fv = (int) trunc(sine_grass_params_lawn_length_get()*sine_grass_get_lawn_length_variation_frac()); 
               sine_grass_params_lawn_length_variation_max_set(fv);
               inpie_again = 1;
            }
            if(tr == -2){
               inpie_again = 0;
            }
            succ = 1;
         }
         if(!succ && strcmp(val, "nade") == 0){
            fprintf(stdout, "%s - Switch to Nadelper\n", val);
            escwyp_switch_method(3);
            succ = 1;
         }
         if(!succ && strcmp(val, "samp") == 0){
            fprintf(stdout, "%s - Switch to Samplecast\n", val);
            escwyp_switch_method(4);
            //samplecast_set_init_value(val);
            //samplecast_set_vorfakts(*tmp_data, val);
            int mo = samplecast_get_mode();
            succ = 1;
         }
         if(!succ && strcmp(val, "spra") == 0){
            fprintf(stdout, "%s - Switch to Spratz\n", val);
            escwyp_switch_method(5);
            float yf = spratz_get_y_fact();
            float xf = spratz_get_x_fact();
            float de = spratz_get_depth();
            float sr = spratz_get_samplerate();
            fprintf(stdout, "////\n - Spratz\n[y_fact=%f][x_fact=%f][depth=%f][samplerate=%f]\n////\n", yf, xf, de, sr);
            succ = 1;
         }
         if(!succ && strcmp(val, "rec") == 0){
            fprintf(stdout, "%s - Switch to Rec\n", val);
            printstatus();
            succ = 1;
         }
         if(!succ && strcmp(val, "rec0") == 0){
            fprintf(stdout, "%s - Switch to Rec\n", val);
            outTxtStop(); //Call this to stop recording or cancel an arming with outTxtRecOnArm()
         }
         if(!succ && strcmp(val, "rec1") == 0){
            fprintf(stdout, "%s - Switch to Rec\n", val);
            outTxtRec(); //Call this to start recording now
         }
         if(!succ && strcmp(val, "reca") == 0){
            fprintf(stdout, "%s - Switch to Rec\n", val);
            outTxtRecOnArm(val); //Call this to start recording after outTxtNotes() has been called
         }
         if(!succ && strcmp(val, "recz") == 0){
            fprintf(stdout, "%s - Switch to Rec\n", val);
            outTxtRecOffArm(val); //Call this to stop recording once outTxtSilence() has been called
         }
   }
   return succ;

}

static void escwyp_terminal_print_menu()
{

   fprintf(stdout, "////\nSoundmethods:[chai][robi][gras][nade][samp][spra]  Exit:[end][Ctrl-D]\n////\n");
   fprintf(stdout, "////\nRec Options:[rec][rec0][rec1][reca][recz]\n////\n");

}

static void escwyp_terminal_print_submenu()
{

   int csm = 0;
   csm = get_current_sound_func();
   fprintf(stdout, "CURRR %i\n", csm);

   switch(csm){
      case 1: {
                 fprintf(stdout, "////\n - Chain\n[chde=][chsi=][chmo=]\n////\n");
                 float chde = get_chain_delta();
                 float chsi = get_sined_chain_freq();
                 int chmo = get_chain_mode();
                 fprintf(stdout, "////\n - Chain\n[chde=%f][chsi=%f][chmo=%i]\n////\n", chde, chsi, chmo);
                 break;
              }
      case 3: {
                 float fv = sine_robin_get_distrib_center();
                 float fv2 = sine_robin_get_distrib_height();
                 float fv3 = sine_robin_get_distrib_height_fine();
                 float fv4 = sine_robin_get_distrib_height_fine_frac();
                 int iv = sine_robin_get_distrib_low();
                 int iv2 = sine_robin_get_distrib_high();
                 int iv3 = sine_robin_get_distrib_function();
                 fprintf(stdout, "////\n - Sine Robin\n[srdc=%f][srdh=%f][srdhf=%f][srdhff=%f][srdl=%i][srdh=%i][srdf=%i]\n////\n", fv, fv2, fv3, fv4, iv, iv2, iv3);
                 break;
              }
      case 4: {
                 int iv = sine_grass_get_grass_mowed();
                 float fv = sine_grass_get_grass_hill_fraction();
                 float fv2 = sine_grass_get_lawn_length_variation_frac();
                 fprintf(stdout, "////\n - SineGrass\n[grmo=%i][grhf=%f][grll=%f]\n////\n", iv, fv, fv2);
                 break;
              }
      case 5: {
                 int npmnf = nadelper_get_max_num_freqs();
                 float npns = nadelper_get_nadel_size();
                 int npnf = nadelper_get_num_freqs();
                 int nphf = nadelper_get_highest_freq();
                 int npfss = nadelper_get_freq_step_size();
                 int nprs = nadelper_get_random_step_size_active();
                 int nprr = nadelper_get_step_size_random_range();
                 fprintf(stdout, "////\n - Nadelper\n[npmnf=%i][npns=%f][npnf=%i][nphf=%i][npfss=%i][nprs=%i][nprr=%i]\n////\n", npmnf, npns, npnf, nphf, npfss, nprs, nprr);
                 break;
              }
      case 6: {
                 fprintf(stdout, "////\n - Samplecast\n");
                 int i;
                 for(i = 0; i < 10; ++i){
                    float vf = samplecast_get_vorfakts(i);
                    fprintf(stdout, "[scvf%i=%f]", i, vf);
                 }
                 fprintf(stdout, "\n");
                 float iv = samplecast_get_init_value();
                 int md = samplecast_get_mode();
                 int mo = samplecast_get_mode_opt();
                 fprintf(stdout, "[scin=%f][scmd=%i][scmo=%i]\n", iv, md, mo);
                 break;
              }
      case 7: {
                 float yf = spratz_get_y_fact();
                 float xf = spratz_get_x_fact();
                 float de = spratz_get_depth();
                 float sr = spratz_get_samplerate();
                 fprintf(stdout, "////\n - Spratz\n[y_fact=%f][x_fact=%f][depth=%f][samplerate=%f]\n////\n", yf, xf, de, sr);
                 break;
              }
   }
}

void escwyp_terminal_menu()
{

   inpie_again = 0;
   char inpie[5] = "star";
   char *reti = NULL;
   fprintf(stdout, "////\n - Welcome to ESCWYP -\n////\n");
   escwyp_terminal_print_menu();
   while(1){
      //fprintf(stdout, "Davor. %s. %i\n", inpie, inpie_again);
      if(inpie_again == 0){
         reti = fgets(inpie, 6, stdin);
         if(reti){
            int nl_found = stripnl(inpie, 5);
            if(nl_found == -1){
               cleanput();
            }
            int ev = evaluate_str(inpie, 5);
            escwyp_terminal_print_menu();
            escwyp_terminal_print_submenu();
            if(ev == 2){
               break;
            }
         }else{
            fprintf(stdout, "Nix da. Bail.\n");
            break;
         }
      }else{
         int ev = evaluate_str(inpie, 5);
         escwyp_terminal_print_menu();
         escwyp_terminal_print_submenu();
      }
   }
   shutdown_stuff();

}
